#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "shoot2three4xi.py">
#<abstract4xi abstract = "shoots to direction three"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'shoot2three2xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from sphere4xi import init_sphere2three4xi 
from sphere4xi import set_sphere2three4xi 
from sphere4xi import get_sphere2three4xi 

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three104xi            # 10   - 90 
global shot2three1004xi           # 100  -    
global shot2three2004xi    
global shot2three3004xi
global shot2three4004xi
global shot2three5004xi
global shot2three6004xi
global shot2three7004xi
global shot2three8004xi
global shot2three9004xi
global shot2three10004xi            
global shot2three11004xi
global shot2three12004xi
global shot2three13004xi
global shot2three14004xi
global shot2three15004xi
global shot2three16004xi
global shot2three17004xi
global shot2three18004xi
global shot2three19004xi
global shot2three20004xi
global shot2three21004xi
global shot2three22004xi
global shot2three23004xi
global shot2three24004xi
global shot2three25004xi
global shot2three26004xi
global shot2three27004xi
global shot2three28004xi
global shot2three29004xi
global shot2three30004xi
global shot2three31004xi
global shot2three32004xi
global shot2three33004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three104xi = {
                1:'0x0y-39z',
                2:'0x0y-69z',
                3:'0x19y-4z',
                4:'0x1y-69z',
                5:'0x2y-69z',
                6:'0x3y-69z',
                7:'0x4y-69z',
                8:'0x53y-26z',
                9:'0x7y-29z',
                10:'0x8y-39z',
                11:'0x9y-38z',
                12:'10x7y-58z',
                13:'11x44y-19z',
                14:'13x0y-58z',
                15:'13x44y-19z',
                16:'15x43y-19z',
                17:'18x42y-18z',
                18:'1x19y-4z',
                19:'1x44y-21z',
                20:'1x4y-69z',
                21:'1x5y-69z',
                22:'1x7y-28z',
                23:'1x8y-28z',
                24:'1x9y-2z',
                25:'20x41y-18z',
                26:'21x74y-45z',
                27:'22x40y-17z',
                28:'22x65y-40z',
                29:'23x29y-13z',
                30:'24x28y-12z',
                31:'24x39y-17z',
                32:'26x27y-12z',
                33:'26x64y-39z',
                34:'27x26y-11z',
                35:'27x38y-16z',
                36:'29x24y-11z',
                37:'29x63y-38z',
                38:'2x19y-4z',
                39:'2x5y-69z',
                40:'2x6y-69z',
                41:'2x8y-28z',
                42:'2x9y-1z',
                43:'2x9y-2z',
                44:'30x23y-11z',
                45:'31x21y-10z',
                46:'33x62y-37z',
                47:'36x60y-37z',
                48:'39x59y-36z',
                49:'3x45y-21z',
                50:'3x6y-59z',
                51:'3x6y-69z',
                52:'3x8y-28z',
                53:'3x9y-1z',
                54:'43x57y-35z',
                55:'46x55y-35z',
                56:'49x52y-34z',
                57:'4x5y-18z',
                58:'4x6y-59z',
                59:'4x8y-1z',
                60:'4x8y-28z',
                61:'4x9y-1z',
                62:'52x36y-27z',
                63:'52x50y-33z',
                64:'54x47y-32z',
                65:'57x45y-32z',
                66:'5x5y-18z',
                67:'5x7y-59z',
                68:'5x8y-1z',
                69:'5x8y-28z',
                70:'6x44y-20z',
                71:'6x4y-18z',
                72:'6x5y-18z',
                73:'6x7y-1z',
                74:'6x7y-59z',
                75:'6x8y-28z',
                76:'7x6y0z',
                77:'7x7y-59z',
                78:'7x7y0z',
                79:'8x0y-18z',
                80:'8x44y-20z',
                81:'8x5y0z',
                82:'8x7y-58z',
                83:'9x7y-58z'}
       

shot2three1004xi = {
                1:'0x0y-99z',
                2:'0x1y-99z',
                3:'0x23y-97z',
                4:'0x2y-99z',
                5:'0x3y-99z',
                6:'0x4y-99z',
                7:'0x97y-24z',
                8:'10x12y-98z',
                9:'10x28y-95z',
                10:'10x83y-53z',
                11:'10x96y-22z',
                12:'11x12y-98z',
                13:'12x28y-94z',
                14:'12x89y-41z',
                15:'13x12y-98z',
                16:'14x12y-98z',
                17:'14x28y-94z',
                18:'14x83y-52z',
                19:'15x12y-98z',
                20:'15x96y-21z',
                21:'16x28y-94z',
                22:'17x11y-97z',
                23:'17x89y-40z',
                24:'18x28y-94z',
                25:'19x83y-51z',
                26:'1x24y-96z',
                27:'1x2y-99z',
                28:'1x5y-99z',
                29:'1x6y-99z',
                30:'1x83y-55z',
                31:'20x28y-93z',
                32:'20x95y-20z',
                33:'21x0y-97z',
                34:'22x28y-93z',
                35:'22x88y-39z',
                36:'23x82y-50z',
                37:'24x27y-92z',
                38:'25x94y-19z',
                39:'26x26y-92z',
                40:'26x88y-39z',
                41:'28x26y-92z',
                42:'28x81y-50z',
                43:'2x25y-96z',
                44:'2x2y-99z',
                45:'2x7y-99z',
                46:'30x25y-91z',
                47:'30x93y-18z',
                48:'31x86y-38z',
                49:'32x24y-91z',
                50:'32x80y-49z',
                51:'34x22y-90z',
                52:'35x91y-17z',
                53:'36x79y-48z',
                54:'36x85y-37z',
                55:'3x26y-96z',
                56:'3x3y-99z',
                57:'3x89y-43z',
                58:'3x8y-99z',
                59:'3x9y-99z',
                60:'40x71y-57z',
                61:'40x83y-36z',
                62:'40x90y-16z',
                63:'41x77y-47z',
                64:'44x69y-56z',
                65:'44x88y-15z',
                66:'45x75y-46z',
                67:'45x81y-35z',
                68:'48x67y-55z',
                69:'49x73y-45z',
                70:'49x79y-34z',
                71:'49x85y-14z',
                72:'4x3y-99z',
                73:'4x9y-99z',
                74:'52x65y-54z',
                75:'53x71y-44z',
                76:'53x83y-13z',
                77:'54x77y-33z',
                78:'56x62y-53z',
                79:'57x68y-43z',
                80:'58x74y-32z',
                81:'58x80y-12z',
                82:'59x60y-53z',
                83:'5x10y-99z',
                84:'5x26y-96z',
                85:'5x4y-99z ',
                86:'5x83y-54z',
                87:'5x97y-23z',
                88:'61x66y-43z',
                89:'62x71y-31z',
                90:'62x77y-11z',
                91:'63x57y-52z',
                92:'65x63y-42z',
                93:'66x54y-51z',
                94:'66x68y-30z',
                95:'66x73y-10z',
                96:'68x59y-41z',
                97:'69x50y-50z',
                98:'69x65y-29z',
                99:'6x11y-99z',
                100:'6x4y-99z',
                101:'70x70y-9z',
                102:'72x56y-40z',
                103:'73x145y-116z',
                104:'73x61y-28z',
                105:'74x66y-8z',
                106:'75x52y-39z',
                107:'76x57y-27z',
                108:'77x62y-7z',
                109:'79x53y-26z',
                110:'7x11y-99z',
                111:'7x27y-95z',
                112:'7x90y-42z',
                113:'80x58y-6z',
                114:'86x0y-49z',
                115:'8x0y-99z',
                116:'8x27y-95z',
                117:'9x0y-99z',
                118:'9x11y-98z'}


shot2three2004xi = {
                1:'0x0y-199z',
                2:'0x194y-48z',
                3:'0x1y-199z',
                4:'0x3y-199z',
                5:'0x47y-194z',
                6:'0x5y-199z',
                7:'0x7y-199z',
                8:'105x130y-109z',
                9:'107x142y-89z',
                10:'107x166y-26z',
                11:'108x154y-66z',
                12:'10x194y-46z',
                13:'10x8y-199z',
                14:'112x125y-107z',
                15:'115x137y-87z',
                16:'116x149y-65z',
                17:'116x160y-24z',
                18:'119x120y-106z',
                19:'11x167y-108z',
                20:'11x20y-198z',
                21:'11x53y-192z',
                22:'123x132y-86z',
                23:'124x143y-63z',
                24:'125x154y-22z',
                25:'126x114y-104z',
                26:'12x8y-199z',
                27:'130x126y-84z',
                28:'132x136y-61z',
                29:'133x108y-102z',
                30:'133x147y-20z',
                31:'137x119y-82z',
                32:'139x101y-101z',
                33:'139x130y-59z',
                34:'13x22y-198z',
                35:'140x140y-18z',
                36:'144x112y-80z',
                37:'146x123y-57z',
                38:'148x133y-16z',
                39:'14x54y-191z',
                40:'150x105y-78z',
                41:'153x115y-55z',
                42:'155x125y-14z',
                43:'159x107y-53z',
                44:'15x180y-85z',
                45:'15x22y-198z',
                46:'161x117y-12z',
                47:'173x0y-99z',
                48:'17x0y-199z',
                49:'17x55y-191z',
                50:'18x23y-197z',
                51:'1x2y-199z',
                52:'1x9y-199z',
                53:'20x167y-107z',
                54:'20x193y-44z',
                55:'20x24y-197z',
                56:'21x56y-190z',
                57:'23x24y-197z',
                58:'25x179y-83z',
                59:'25x57y-189z',
                60:'26x24y-196z',
                61:'28x24y-196z',
                62:'28x57y-189z',
                63:'29x167y-105z',
                64:'2x11y-199z',
                65:'2x166y-110z',
                66:'2x49y-193z',
                67:'30x193y-42z',
                68:'31x24y-196z',
                69:'32x57y-188z',
                70:'34x179y-81z',
                71:'34x23y-195z',
                72:'36x57y-188z',
                73:'38x166y-103z',
                74:'3x13y-199z',
                75:'3x4y-199z',
                76:'40x191y-40z',
                77:'40x56y-187z',
                78:'44x177y-79z',
                79:'44x56y-186z',
                80:'47x165y-101z',
                81:'49x55y-185z',
                82:'4x15y-199z',
                83:'4x5y-199z',
                84:'50x189y-38z',
                85:'53x176y-78z',
                86:'53x53y-185z',
                87:'56x163y-100z',
                88:'57x149y-119z',
                89:'57x52y-184z',
                90:'5x50y-193z',
                91:'60x187y-36z',
                92:'61x50y-183z',
                93:'63x173y-76z',
                94:'65x147y-117z',
                95:'65x161y-98z',
                96:'65x48y-182z',
                97:'69x45y-181z',
                98:'6x16y-199z',
                99:'6x179y-87z',
                100:'6x6y-199z',
                101:'70x183y-34z',
                102:'72x170y-74z',
                103:'73x145y-116z',
                104:'73x158y-96z',
                105:'73x227y-181z',
                106:'7x18y-199z',
                107:'7x52y-192z',
                108:'80x180y-32z',
                109:'81x142y-114z',
                110:'81x167y-72z',
                111:'82x155y-94z',
                112:'89x138y-112z',
                113:'89x176y-30z',
                114:'8x7y-199z',
                115:'90x163y-70z',
                116:'91x151y-93z',
                117:'97x134y-111z',
                118:'98x171y-28z',
                119:'99x147y-91z',
                120:'99x159y-68z',
                121:'9x19y-198z'}


shot2three3004xi = {
                1:'0x11y-299z',
                2:'0x1y-299z',
                3:'0x291y-72z',
                4:'0x2y-299z',
                5:'0x5y-299z',
                6:'0x70y-291z',
                7:'0x8y-299z',
                8:'104x68y-272z',
                9:'105x275y-51z',
                10:'108x256y-111z',
                11:'110x217y-174z',
                12:'110x238y-145z',
                13:'11x27y-298z',
                14:'11x78y-289z',
                15:'120x270y-48z',
                16:'122x213y-171z',
                17:'122x251y-108z',
                18:'123x233y-142z',
                19:'12x11y-299z',
                20:'134x207y-169z',
                21:'134x264y-45z',
                22:'136x227y-139z',
                23:'136x245y-105z',
                24:'146x201y-166z',
                25:'148x257y-42z',
                26:'149x221y-137z',
                27:'149x238y-103z',
                28:'14x29y-298z',
                29:'157x195y-164z',
                30:'15x12y-299z',
                31:'15x291y-69z',
                32:'161x214y-134z',
                33:'161x249y-39z',
                34:'162x231y-100z',
                35:'168x188y-161z',
                36:'16x80y-288z',
                37:'173x206y-131z',
                38:'174x223y-97z',
                39:'175x240y-36z',
                40:'179x180y-159z',
                41:'17x251y-163z',
                42:'17x31y-297z',
                43:'184x198y-129z',
                44:'186x214y-94z',
                45:'187x231y-33z',
                46:'189x171y-156z',
                47:'18x13y-299z',
                48:'195x189y-126z',
                49:'198x205y-91z',
                50:'199x162y-154z',
                51:'199x221y-30z',
                52:'1x14y-299z',
                53:'206x179y-123z',
                54:'209x152y-151z',
                55:'209x195y-88z',
                56:'20x33y-297z',
                57:'211x211y-27z',
                58:'216x169y-120z',
                59:'21x82y-287z',
                60:'220x184y-86z',
                61:'222x200y-24z',
                62:'225x158y-118z',
                63:'230x173y-83z',
                64:'232x188y-21z',
                65:'239x161y-80z',
                66:'23x270y-128z',
                67:'23x34y-297z',
                68:'242x175y-18z',
                69:'25x0y-298z',
                70:'26x83y-286z',
                71:'27x35y-296z',
                72:'2x3y-299z',
                73:'30x251y-160z',
                74:'30x290y-66z',
                75:'31x36y-296z',
                76:'32x85y-285z',
                77:'34x36y-295z',
                78:'37x269y-125z',
                79:'37x85y-284z',
                80:'39x36y-295z',
                81:'3x17y-299z',
                82:'3x73y-290z',
                83:'43x36y-294z',
                84:'43x86y-284z',
                85:'44x251y-158z',
                86:'45x289y-63z',
                87:'47x36y-294z',
                88:'49x86y-283z',
                89:'4x20y-299z',
                90:'4x250y-165z',
                91:'4x6y-299z',
                92:'51x35y-293z',
                93:'52x268y-122z',
                94:'55x86y-282z',
                95:'57x250y-155z',
                96:'61x287y-60z',
                97:'61x85y-280z',
                98:'66x266y-119z',
                99:'67x84y-279z',
                100:'6x22y-299z',
                101:'71x248y-152z',
                102:'73x227y-181z',
                103:'73x82y-278z',
                104:'76x284y-57z',
                105:'79x80y-277z',
                106:'7x76y-290z',
                107:'7x7y-299z',
                108:'80x264y-117z',
                109:'81x305y-245z',
                110:'84x245y-150z',
                111:'85x224y-179z',
                112:'85x78y-276z',
                113:'91x280y-54z',
                114:'92x75y-275z',
                115:'94x260y-114z',
                116:'97x242y-147z',
                117:'98x221y-176z',
                118:'98x72y-274z',
                119:'9x25y-298z',
                120:'9x269y-130z',
                121:'9x9y-299z'}
                
shot2three4004xi = {
                1:'0x11y-399z',
                2:'0x388y-96z',
                3:'0x3y-399z',
                4:'0x7y-399z',
                5:'0x94y-388z',
                6:'101x379y-76z',
                7:'101x381y-306z',
                8:'106x107y-370z',
                9:'107x352y-156z',
                10:'10x101y-386z',
                11:'112x327y-200z',
                12:'114x104y-368z',
                13:'114x299y-238z',
                14:'121x374y-72z',
                15:'122x100y-367z',
                16:'126x347y-152z',
                17:'12x33y-398z',
                18:'12x359y-174z',
                19:'130x322y-196z',
                20:'130x96y-365z',
                21:'131x295y-235z',
                22:'138x91y-363z',
                23:'13x12y-399z',
                24:'141x367y-68z',
                25:'145x341y-148z',
                26:'147x290y-232z',
                27:'147x317y-193z',
                28:'15x104y-385z',
                29:'15x36y-398z',
                30:'160x360y-64z',
                31:'163x284y-229z',
                32:'163x335y-145z',
                33:'165x310y-189z',
                34:'16x14y-399z',
                35:'179x277y-225z',
                36:'179x352y-60z',
                37:'181x327y-141z',
                38:'182x303y-186z',
                39:'18x39y-397z',
                40:'194x269y-222z',
                41:'197x342y-56z',
                42:'198x295y-182z',
                43:'199x318y-137z',
                44:'1x15y-399z',
                45:'1x1y-399z',
                46:'20x16y-399z',
                47:'20x388y-92z',
                48:'210x260y-219z',
                49:'215x285y-179z',
                50:'215x332y-52z',
                51:'216x308y-133z',
                52:'224x250y-215z',
                53:'22x107y-384z',
                54:'22x41y-397z',
                55:'230x275y-175z',
                56:'232x298y-130z',
                57:'233x321y-48z',
                58:'239x240y-212z',
                59:'23x334y-217z',
                60:'246x264y-172z',
                61:'249x286y-126z',
                62:'24x17y-398z',
                63:'250x308y-45z',
                64:'253x228y-208z',
                65:'260x252y-168z',
                66:'264x273y-122z',
                67:'266x216y-205z',
                68:'266x295y-41z',
                69:'274x239y-164z',
                70:'278x203y-202z',
                71:'279x260y-118z',
                72:'27x44y-396z',
                73:'281x281y-37z',
                74:'288x225y-161z',
                75:'28x109y-383z',
                76:'293x246y-114z',
                77:'296x266y-33z',
                78:'2x19y-399z',
                79:'301x211y-157z',
                80:'306x231y-110z',
                81:'310x251y-29z',
                82:'319x215y-107z',
                83:'31x360y-170z',
                84:'31x45y-396z',
                85:'322x234y-25z',
                86:'34x0y-398z',
                87:'35x111y-382z',
                88:'36x47y-395z',
                89:'3x5y-399z',
                90:'40x387y-88z',
                91:'41x335y-214z',
                92:'41x48y-394z',
                93:'42x113y-381z',
                94:'46x48y-394z',
                95:'4x23y-399z',
                96:'4x98y-387z',
                97:'50x114y-379z',
                98:'50x359y-167z',
                99:'52x49y-393z',
                100:'57x115y-378z',
                101:'57x48y-392z',
                102:'58x334y-210z',
                103:'5x333y-220z',
                104:'61x386y-84z',
                105:'63x48y-392z',
                106:'65x115y-377z',
                107:'68x46y-391z',
                108:'69x358y-163z',
                109:'6x27y-399z',
                110:'6x8y-399z',
                111:'73x114y-376z',
                112:'76x333y-207z',
                113:'81x113y-374z',
                114:'81x383y-80z',
                115:'88x355y-159z',
                116:'89x112y-373z',
                117:'94x330y-203z',
                118:'97x303y-241z',
                119:'98x110y-371z',
                120:'9x10y-399z',
                121:'9x30y-398z'}

shot2three5004xi = {
                1:'0x117y-485z',
                2:'0x14y-499z',
                3:'0x485y-120z',
                4:'0x4y-499z',
                5:'0x9y-499z',
                6:'101x479y-100z',
                7:'102x142y-468z',
                8:'110x444y-199z',
                9:'112x140y-466z',
                10:'118x413y-254z',
                11:'11x38y-498z',
                12:'121x458y-367z',
                13:'122x137y-464z',
                14:'122x378y-302z',
                15:'127x474y-95z',
                16:'12x126y-483z',
                17:'12x13y-499z',
                18:'132x134y-462z',
                19:'134x440y-195z',
                20:'140x409y-250z',
                21:'143x130y-460z',
                22:'143x374y-298z',
                23:'151x467y-90z',
                24:'153x125y-458z',
                25:'158x434y-190z',
                26:'15x42y-497z',
                27:'15x449y-217z',
                28:'162x403y-246z',
                29:'163x120y-456z',
                30:'163x369y-294z',
                31:'16x16y-499z',
                32:'173x114y-454z',
                33:'176x459y-85z',
                34:'181x427y-185z',
                35:'184x362y-290z',
                36:'184x396y-241z',
                37:'19x130y-482z',
                38:'19x45y-497z',
                39:'1x19y-499z',
                40:'1x2y-499z',
                41:'200x450y-81z',
                42:'204x355y-286z',
                43:'204x418y-181z',
                44:'206x388y-237z',
                45:'20x18y-499z',
                46:'224x346y-282z',
                47:'224x440y-76z',
                48:'226x409y-176z',
                49:'227x379y-233z',
                50:'23x49y-496z',
                51:'243x336y-278z',
                52:'247x428y-71z',
                53:'248x368y-228z',
                54:'248x398y-171z',
                55:'25x20y-498z',
                56:'25x485y-115z',
                57:'262x325y-273z',
                58:'268x357y-224z',
                59:'269x415y-66z',
                60:'270x385y-167z',
                61:'27x134y-480z',
                62:'281x313y-269z',
                63:'288x344y-219z',
                64:'28x52y-496z',
                65:'291x372y-162z',
                66:'291x401y-61z',
                67:'299x300y-265z',
                68:'29x418y-271z',
                69:'307x330y-215z',
                70:'30x21y-498z',
                71:'311x358y-157z',
                72:'312x386y-56z',
                73:'316x285y-261z',
                74:'326x315y-210z',
                75:'330x342y-153z',
                76:'332x270y-256z',
                77:'332x369y-51z',
                78:'33x55y-495z',
                79:'343x299y-206z',
                80:'348x254y-252z',
                81:'349x325y-148z',
                82:'352x352y-46z',
                83:'35x137y-479z',
                84:'360x281y-201z',
                85:'366x307y-143z',
                86:'370x333y-41z',
                87:'376x263y-196z',
                88:'383x289y-138z',
                89:'387x313y-36z',
                90:'399x269y-133z',
                91:'39x450y-213z',
                92:'39x57y-495z',
                93:'3x24y-499z',
                94:'403x293y-31z',
                95:'42x0y-498z',
                96:'44x139y-477z',
                97:'45x59y-494z',
                98:'4x6y-499z',
                99:'50x484y-110z',
                100:'51x419y-267z',
                101:'51x60y-493z',
                102:'53x141y-476z',
                103:'58x61y-492z',
                104:'5x122y-484z',
                105:'5x29y-499z',
                106:'62x143y-474z',
                107:'63x449y-208z',
                108:'65x61y-491z',
                109:'71x61y-491z',
                110:'72x143y-473z',
                111:'73x418y-263z',
                112:'76x482y-105z',
                113:'78x60y-490z',
                114:'7x416y-276z',
                115:'82x144y-471z',
                116:'85x58y-489z',
                117:'87x447y-204z',
                118:'8x10y-499z',
                119:'8x33y-498z',
                120:'92x143y-470z',
                121:'95x416y-259z'}

shot2three6004xi = {
                1:'0x11y-599z',
                2:'0x141y-583z',
                3:'0x17y-599z',
                4:'0x582y-144z',
                5:'0x5y-599z',
                6:'103x70y-586z',
                7:'104x537y-245z',
                8:'110x172y-564z',
                9:'115x500y-310z',
                10:'122x170y-561z',
                11:'122x574y-120z',
                12:'133x533y-239z',
                13:'134x168y-559z',
                14:'13x45y-598z',
                15:'142x496y-305z',
                16:'142x534y-428z',
                17:'146x454y-362z',
                18:'147x165y-557z',
                19:'14x15y-599z',
                20:'152x568y-114z',
                21:'159x161y-555z',
                22:'15x152y-580z',
                23:'161x528y-234z',
                24:'168x491y-300z',
                25:'171x156y-553z',
                26:'171x449y-358z',
                27:'182x561y-109z',
                28:'184x150y-550z',
                29:'189x521y-228z',
                30:'18x50y-597z',
                31:'18x539y-261z',
                32:'195x484y-295z',
                33:'196x144y-548z',
                34:'196x443y-353z',
                35:'19x19y-599z',
                36:'1x23y-599z',
                37:'1x2y-599z',
                38:'208x136y-545z',
                39:'211x551y-103z',
                40:'217x512y-223z',
                41:'221x435y-348z',
                42:'221x476y-290z',
                43:'23x157y-578z',
                44:'23x55y-597z',
                45:'240x540y-97z',
                46:'245x426y-343z',
                47:'245x502y-217z',
                48:'247x466y-284z',
                49:'25x22y-599z',
                50:'269x415y-338z',
                51:'269x528y-91z',
                52:'272x490y-211z',
                53:'273x455y-279z',
                54:'28x59y-596z',
                55:'292x403y-333z',
                56:'296x514y-85z',
                57:'298x442y-274z',
                58:'298x477y-206z',
                59:'30x583y-138z',
                60:'315x390y-328z',
                61:'31x24y-598z',
                62:'322x428y-268z',
                63:'323x498y-79z',
                64:'324x463y-200z',
                65:'337x376y-323z',
                66:'33x161y-576z',
                67:'346x413y-263z',
                68:'349x447y-195z',
                69:'34x502y-326z',
                70:'34x62y-595z',
                71:'350x481y-73z',
                72:'358x360y-318z',
                73:'369x396y-258z',
                74:'373x429y-189z',
                75:'375x463y-67z',
                76:'379x342y-313z',
                77:'37x26y-598z',
                78:'391x378y-252z',
                79:'396x410y-183z',
                80:'399x324y-308z',
                81:'399x443y-61z',
                82:'3x29y-599z',
                83:'40x66y-594z',
                84:'412x358y-247z',
                85:'418x305y-303z',
                86:'419x390y-177z',
                87:'422x422y-55z',
                88:'432x338y-241z',
                89:'43x164y-575z',
                90:'440x369y-172z',
                91:'444x400y-49z',
                92:'451x316y-236z',
                93:'460x346y-166z',
                94:'465x376y-43z',
                95:'479x323y-160z',
                96:'47x540y-256z',
                97:'47x68y-594z',
                98:'484x351y-37z',
                99:'51x0y-597z',
                100:'53x167y-573z',
                101:'54x70y-593z',
                102:'5x7y-599z',
                103:'61x503y-321z',
                104:'61x581y-132z',
                105:'62x72y-592z',
                106:'64x170y-571z',
                107:'69x73y-591z',
                108:'6x147y-581z',
                109:'6x35y-598z',
                110:'75x171y-569z',
                111:'75x539y-250z',
                112:'78x73y-590z',
                113:'86x172y-568z',
                114:'86x73y-589z',
                115:'88x502y-316z',
                116:'8x500y-331z',
                117:'91x579y-126z',
                118:'94x72y-588z',
                119:'98x172y-566z',
                120:'9x12y-599z',
                121:'9x40y-598z'}

shot2three7004xi = {
                1:'0x13y-699z',
                2:'0x165y-680z',
                3:'0x20y-699z',
                4:'0x679y-168z',
                5:'0x6y-699z',
                6:'100x85y-687z',
                7:'101x201y-662z',
                8:'103x586y-368z',
                9:'107x675y-147z',
                10:'110x84y-686z',
                11:'114x201y-660z',
                12:'11x14y-699z',
                13:'11x47y-698z',
                14:'120x82y-684z',
                15:'121x627y-286z',
                16:'128x200y-658z',
                17:'129x613y-496z',
                18:'134x583y-362z',
                19:'142x534y-428z',
                20:'142x670y-140z',
                21:'143x199y-655z',
                22:'155x622y-279z',
                23:'157x196y-653z',
                24:'15x53y-697z',
                25:'165x579y-356z',
                26:'171x192y-650z',
                27:'171x530y-423z',
                28:'177x663y-134z',
                29:'17x177y-676z',
                30:'17x18y-699z',
                31:'186x188y-647z',
                32:'188x616y-273z',
                33:'196x572y-350z',
                34:'200x182y-645z',
                35:'200x524y-417z',
                36:'212x654y-127z',
                37:'214x176y-642z',
                38:'21x59y-697z',
                39:'21x629y-305z',
                40:'221x608y-266z',
                41:'227x565y-344z',
                42:'228x168y-639z',
                43:'229x517y-412z',
                44:'22x22y-699z',
                45:'242x159y-636z',
                46:'247x643y-120z',
                47:'253x598y-260z',
                48:'257x508y-406z',
                49:'258x555y-338z',
                50:'26x64y-696z',
                51:'27x183y-675z',
                52:'280x631y-113z',
                53:'285x586y-253z',
                54:'286x497y-400z',
                55:'288x544y-332z',
                56:'29x25y-698z',
                57:'2x27y-699z',
                58:'2x3y-699z',
                59:'313x485y-395z',
                60:'314x616y-106z',
                61:'317x572y-247z',
                62:'318x531y-326z',
                63:'33x69y-695z',
                64:'341x471y-389z',
                65:'346x600y-99z',
                66:'347x516y-320z',
                67:'348x557y-240z',
                68:'35x680y-161z',
                69:'367x455y-383z',
                70:'36x28y-698z',
                71:'376x499y-313z',
                72:'377x581y-92z',
                73:'378x540y-234z',
                74:'38x188y-673z',
                75:'393x438y-377z',
                76:'403x481y-307z',
                77:'407x521y-227z',
                78:'408x562y-85z',
                79:'40x586y-380z',
                80:'40x73y-694z',
                81:'418x420y-371z',
                82:'430x462y-301z',
                83:'435x501y-220z',
                84:'437x540y-78z',
                85:'43x30y-697z',
                86:'442x400y-365z',
                87:'456x441y-294z',
                88:'462x479y-214z',
                89:'465x517y-71z',
                90:'466x378y-359z',
                91:'47x77y-694z',
                92:'481x418y-288z',
                93:'488x355y-353z',
                94:'488x455y-207z',
                95:'492x492y-64z',
                96:'4x34y-699z',
                97:'504x394y-282z',
                98:'50x192y-671z',
                99:'513x431y-200z',
                100:'518x466y-57z',
                101:'526x369y-275z',
                102:'537x404y-194z',
                103:'542x439y-50z',
                104:'559x377y-187z',
                105:'55x630y-298z',
                106:'55x80y-693z',
                107:'565x410y-43z',
                108:'62x195y-669z',
                109:'63x82y-692z',
                110:'6x8y-699z',
                111:'71x586y-374z',
                112:'71x678y-154z',
                113:'72x84y-691z',
                114:'74x198y-667z',
                115:'7x41y-698z',
                116:'81x85y-689z',
                117:'87x200y-664z',
                118:'88x629y-292z',
                119:'8x171y-678z',
                120:'91x85y-688z',
                121:'9x583y-386z'}

shot2three8004xi = {
                1:'0x15y-799z',
                2:'0x23y-799z',
                3:'0x776y-192z',
                4:'0x7y-799z',
                5:'100x229y-759z',
                6:'101x719y-334z',
                7:'104x98y-787z',
                8:'108x691y-565z',
                9:'115x230y-757z',
                10:'115x97y-785z',
                11:'117x669y-421z',
                12:'11x666y-441z',
                13:'122x772y-168z',
                14:'126x96y-784z',
                15:'129x613y-496z',
                16:'131x230y-754z',
                17:'137x93y-782z',
                18:'139x716y-326z',
                19:'13x16y-799z',
                20:'13x54y-798z',
                21:'147x229y-752z',
                22:'153x666y-414z',
                23:'162x610y-490z',
                24:'162x766y-161z',
                25:'163x227y-749z',
                26:'177x711y-319z',
                27:'179x224y-746z',
                28:'189x661y-407z',
                29:'18x61y-797z',
                30:'195x606y-483z',
                31:'196x220y-743z',
                32:'19x21y-799z',
                33:'203x758y-153z',
                34:'20x203y-773z',
                35:'212x215y-740z',
                36:'215x704y-312z',
                37:'225x654y-400z',
                38:'229x208y-737z',
                39:'229x599y-477z',
                40:'243x748y-145z',
                41:'245x201y-734z',
                42:'24x67y-796z',
                43:'252x695y-304z',
                44:'25x719y-348z',
                45:'260x645y-393z',
                46:'261x192y-731z',
                47:'262x591y-471z',
                48:'26x25y-799z',
                49:'277x182y-727z',
                50:'282x735y-137z',
                51:'290x683y-297z',
                52:'294x580y-464z',
                53:'295x634y-386z',
                54:'2x31y-799z',
                55:'2x3y-799z',
                56:'30x73y-796z',
                57:'31x209y-771z',
                58:'321x721y-129z',
                59:'326x670y-290z',
                60:'327x568y-458z',
                61:'330x621y-379z',
                62:'33x29y-798z',
                63:'358x554y-451z',
                64:'358x704y-121z',
                65:'362x654y-282z',
                66:'364x606y-372z',
                67:'37x79y-795z',
                68:'389x538y-444z',
                69:'395x685y-113z',
                70:'397x590y-365z',
                71:'398x637y-275z',
                72:'40x777y-184z',
                73:'41x32y-798z',
                74:'420x520y-438z',
                75:'430x571y-358z',
                76:'431x665y-105z',
                77:'432x617y-267z',
                78:'449x501y-431z',
                79:'44x215y-769z',
                80:'45x83y-794z',
                81:'461x550y-351z',
                82:'465x596y-260z',
                83:'466x642y-97z',
                84:'46x669y-434z',
                85:'478x480y-424z',
                86:'492x528y-344z',
                87:'498x572y-252z',
                88:'49x35y-797z',
                89:'500x617y-90z',
                90:'506x457y-417z',
                91:'521x504y-336z',
                92:'529x547y-244z',
                93:'532x432y-411z',
                94:'532x591y-82z',
                95:'549x478y-329z',
                96:'54x88y-793z',
                97:'557x406y-404z',
                98:'558x521y-237z',
                99:'563x563y-74z',
                100:'576x451y-322z',
                101:'57x219y-767z',
                102:'587x492y-229z',
                103:'592x533y-66z',
                104:'5x39y-799z',
                105:'602x422y-315z',
                106:'613x462y-221z',
                107:'620x502y-58z',
                108:'639x431y-214z',
                109:'63x720y-341z',
                110:'63x91y-792z',
                111:'645x469y-50z',
                112:'71x223y-764z',
                113:'72x94y-791z',
                114:'7x10y-799z',
                115:'81x775y-176z',
                116:'82x670y-428z',
                117:'82x96y-789z',
                118:'85x226y-762z',
                119:'8x46y-798z',
                120:'93x97y-788z',
                121:'9x196y-775z'}

shot2three9004xi = {
                1:'0x17y-899z',
                2:'0x26y-899z',
                3:'0x873y-216z',
                4:'0x8y-899z',
                5:'104x110y-887z',
                6:'10x220y-872z',
                7:'112x257y-854z',
                8:'113x809y-376z',
                9:'117x110y-885z',
                10:'120x768y-628z',
                11:'129x109y-883z',
                12:'12x750y-496z',
                13:'130x259y-852z',
                14:'132x753y-474z',
                15:'137x868y-190z',
                16:'142x108y-882z',
                17:'145x690y-558z',
                18:'147x259y-849z',
                19:'14x18y-899z',
                20:'14x60y-897z',
                21:'154x105y-880z',
                22:'156x806y-367z',
                23:'165x258y-846z',
                24:'172x750y-466z',
                25:'182x687y-551z',
                26:'183x256y-842z',
                27:'183x862y-181z',
                28:'199x800y-359z',
                29:'202x252y-839z',
                30:'20x68y-897z',
                31:'213x744y-458z',
                32:'21x23y-899z',
                33:'220x248y-836z',
                34:'220x681y-544z',
                35:'228x853y-172z',
                36:'22x228y-870z',
                37:'239x242y-833z',
                38:'242x792y-351z',
                39:'253x736y-450z',
                40:'257x234y-829z',
                41:'257x674y-537z',
                42:'273x841y-163z',
                43:'276x226y-826z',
                44:'27x75y-896z',
                45:'284x781y-343z',
                46:'28x809y-392z',
                47:'293x726y-443z',
                48:'294x216y-822z',
                49:'294x665y-529z',
                50:'29x28y-899z',
                51:'2x35y-899z',
                52:'2x4y-899z',
                53:'312x205y-818z',
                54:'317x827y-154z',
                55:'326x769y-334z',
                56:'331x653y-522z',
                57:'332x714y-435z',
                58:'34x82y-895z',
                59:'35x235y-867z',
                60:'361x811y-145z',
                61:'367x639y-515z',
                62:'367x753y-326z',
                63:'371x699y-427z',
                64:'37x33y-898z',
                65:'403x623y-507z',
                66:'403x792y-136z',
                67:'408x736y-317z',
                68:'409x682y-419z',
                69:'42x88y-894z',
                70:'438x605y-500z',
                71:'445x771y-128z',
                72:'447x663y-411z',
                73:'447x716y-309z',
                74:'45x874y-207z',
                75:'46x36y-898z',
                76:'472x585y-492z',
                77:'483x642y-403z',
                78:'485x748y-119z',
                79:'486x694y-301z',
                80:'49x241y-865z',
                81:'506x564y-485z',
                82:'519x619y-395z',
                83:'51x94y-893z',
                84:'524x670y-292z',
                85:'525x722y-110z',
                86:'52x753y-489z',
                87:'538x540y-477z',
                88:'553x594y-387z',
                89:'55x39y-897z',
                90:'560x644y-283z',
                91:'562x694y-101z',
                92:'569x514y-470z',
                93:'586x567y-379z',
                94:'595x616y-275z',
                95:'599x486y-462z',
                96:'599x665y-92z',
                97:'5x44y-898z',
                98:'618x538y-370z',
                99:'61x99y-892z',
                100:'627x457y-454z',
                101:'628x586y-266z',
                102:'633x633y-83z',
                103:'648x507y-362z',
                104:'64x247y-862z',
                105:'660x554y-258z',
                106:'666x600y-74z',
                107:'677x474y-354z',
                108:'690x520y-249z',
                109:'697x564y-65z',
                110:'70x810y-384z',
                111:'718x484y-240z',
                112:'71x103y-891z',
                113:'726x527y-56z',
                114:'80x251y-860z',
                115:'82x106y-889z',
                116:'8x11y-899z',
                117:'91x872y-198z',
                118:'92x754y-481z',
                119:'93x108y-888z',
                120:'96x255y-857z',
                121:'9x52y-898z'}
                                       
shot2three10004xi = {
                1:'0x19y-999z',
                2:'0x29y-999z',
                3:'0x970y-240z',
                4:'0x9y-999z',
                5:'101x969y-220z',
                6:'102x838y-535z',
                7:'103x120y-987z',
                8:'107x283y-952z',
                9:'116x122y-985z',
                10:'11x245y-969z',
                11:'11x58y-998z',
                12:'125x286y-949z',
                13:'126x899y-417z',
                14:'130x122y-983z',
                15:'132x845y-691z',
                16:'143x122y-982z',
                17:'144x287y-946z',
                18:'147x837y-526z',
                19:'14x833y-552z',
                20:'152x965y-211z',
                21:'157x120y-980z',
                22:'161x767y-620z',
                23:'164x288y-943z',
                24:'16x20y-999z',
                25:'16x67y-997z',
                26:'171x117y-978z',
                27:'174x895y-408z',
                28:'184x287y-940z',
                29:'191x833y-518z',
                30:'203x763y-612z',
                31:'203x958y-201z',
                32:'204x284y-936z',
                33:'221x889y-399z',
                34:'224x280y-933z',
                35:'22x76y-996z',
                36:'236x827y-509z',
                37:'244x757y-604z',
                38:'245x275y-929z',
                39:'24x26y-999z',
                40:'254x948y-191z',
                41:'25x253y-966z',
                42:'265x269y-925z',
                43:'269x880y-390z',
                44:'281x818y-501z',
                45:'286x260y-921z',
                46:'286x749y-596z',
                47:'303x935y-181z',
                48:'306x251y-917z',
                49:'30x84y-995z',
                50:'316x868y-381z',
                51:'31x899y-435z',
                52:'325x807y-492z',
                53:'327x240y-913z',
                54:'327x738y-588z',
                55:'32x32y-998z',
                56:'346x228y-909z',
                57:'353x919y-171z',
                58:'362x854y-371z',
                59:'368x725y-580z',
                60:'369x793y-483z',
                61:'38x91y-995z',
                62:'39x261y-964z',
                63:'3x39y-999z',
                64:'3x4y-999z',
                65:'401x901y-162z',
                66:'408x710y-572z',
                67:'408x837y-362z',
                68:'412x777y-474z',
                69:'41x36y-998z',
                70:'448x693y-564z',
                71:'448x880y-152z',
                72:'453x818y-353z',
                73:'455x758y-466z',
                74:'47x98y-993z',
                75:'487x673y-556z',
                76:'494x857y-142z',
                77:'496x737y-457z',
                78:'497x796y-343z',
                79:'50x971y-230z',
                80:'51x40y-997z',
                81:'525x651y-547z',
                82:'537x714y-448z',
                83:'539x831y-132z',
                84:'540x771y-334z',
                85:'55x268y-961z',
                86:'562x626y-539z',
                87:'577x688y-439z',
                88:'57x104y-992z',
                89:'582x745y-325z',
                90:'583x802y-122z',
                91:'58x837y-543z',
                92:'598x600y-530z',
                93:'615x660y-430z',
                94:'61x43y-997z',
                95:'622x716y-315z',
                96:'625x772y-112z',
                97:'632x571y-522z',
                98:'652x630y-421z',
                99:'661x684y-306z',
                100:'665x540y-513z',
                101:'665x739y-102z',
                102:'67x110y-991z',
                103:'687x598y-412z',
                104:'697x508y-505z',
                105:'698x651y-296z',
                106:'6x49y-998z',
                107:'704x704y-92z',
                108:'71x274y-958z',
                109:'720x563y-403z',
                110:'733x615y-286z',
                111:'740x666y-82z',
                112:'752x527y-393z',
                113:'767x578y-277z',
                114:'775x627y-72z',
                115:'78x900y-426z',
                116:'798x538y-267z',
                117:'79x114y-990z',
                118:'807x586y-62z',
                119:'89x279y-955z',
                120:'91x118y-988z',
                121:'9x12y-999z'}                       


shot2three11004xi = {
                1:'0x1067y-264z',
                2:'0x10y-1099z',
                3:'0x21y-1099z',
                4:'0x32y-1099z',
                5:'100x129y-1087z',
                6:'10x14y-1099z',
                7:'112x1066y-243z',
                8:'112x922y-588z',
                9:'114x132y-1085z',
                10:'117x311y-1048z',
                11:'128x134y-1084z',
                12:'12x269y-1066z',
                13:'12x64y-1098z',
                14:'138x314y-1044z',
                15:'139x989y-459z',
                16:'143x134y-1082z',
                17:'144x922y-754z',
                18:'158x134y-1080z',
                19:'159x316y-1041z',
                20:'15x917y-607z',
                21:'161x920y-579z',
                22:'168x1061y-232z',
                23:'173x132y-1078z',
                24:'177x843y-682z',
                25:'180x316y-1037z',
                26:'189x129y-1075z',
                27:'18x22y-1099z',
                28:'18x74y-1097z',
                29:'191x985y-449z',
                30:'202x315y-1034z',
                31:'211x916y-570z',
                32:'223x840y-674z',
                33:'224x1053y-221z',
                34:'224x313y-1030z',
                35:'243x978y-439z',
                36:'247x308y-1026z',
                37:'25x83y-1096z',
                38:'260x909y-560z',
                39:'269x303y-1022z',
                40:'269x833y-665z',
                41:'26x29y-1099z',
                42:'279x1042y-210z',
                43:'27x279y-1063z',
                44:'292x295y-1018z',
                45:'296x968y-429z',
                46:'309x900y-551z',
                47:'314x824y-656z',
                48:'315x287y-1014z',
                49:'334x1028y-199z',
                50:'337x276y-1009z',
                51:'33x92y-1095z',
                52:'347x955y-419z',
                53:'34x989y-479z',
                54:'358x887y-541z',
                55:'359x264y-1005z',
                56:'360x812y-647z',
                57:'36x35y-1098z',
                58:'381x250y-1000z',
                59:'388x1011y-189z',
                60:'398x939y-409z',
                61:'3x43y-1099z',
                62:'3x5y-1099z',
                63:'405x798y-638z',
                64:'406x872y-532z',
                65:'42x101y-1094z',
                66:'43x287y-1060z',
                67:'441x991y-178z',
                68:'449x781y-629z',
                69:'449x921y-398z',
                70:'454x854y-522z',
                71:'46x40y-1098z',
                72:'493x762y-620z',
                73:'493x968y-167z',
                74:'498x900y-388z',
                75:'500x834y-512z',
                76:'52x108y-1093z',
                77:'536x740y-611z',
                78:'544x942y-156z',
                79:'546x811y-502z',
                80:'547x875y-378z',
                81:'56x1068y-253z',
                82:'56x45y-1097z',
                83:'578x716y-602z',
                84:'591x785y-493z',
                85:'593x914y-145z',
                86:'594x849y-367z',
                87:'618x689y-593z',
                88:'61x295y-1057z',
                89:'634x757y-483z',
                90:'63x115y-1092z',
                91:'63x921y-598z',
                92:'640x819y-357z',
                93:'641x883y-134z',
                94:'658x660y-583z',
                95:'676x726y-473z',
                96:'684x787y-347z',
                97:'687x849y-123z',
                98:'68x48y-1096z',
                99:'696x628y-574z',
                100:'717x693y-463z',
                101:'727x753y-336z',
                102:'732x595y-565z',
                103:'732x813y-112z',
                104:'74x121y-1090z',
                105:'756x657y-453z',
                106:'767x559y-555z',
                107:'768x716y-326z',
                108:'774x774y-101z',
                109:'792x620y-443z',
                110:'79x302y-1054z',
                111:'7x54y-1098z',
                112:'807x677y-315z',
                113:'814x733y-90z',
                114:'827x580y-433z',
                115:'844x636y-305z',
                116:'852x690y-80z',
                117:'86x990y-469z',
                118:'878x592y-294z',
                119:'87x126y-1089z',
                120:'888x645y-69z',
                121:'98x307y-1051z'}

shot2three12004xi = {
                1:'0x1164y-288z',
                2:'0x11y-1199z',
                3:'0x23y-1199z',
                4:'106x335y-1147z',
                5:'109x141y-1186z',
                6:'11x15y-1199z',
                7:'122x1163y-265z',
                8:'123x1006y-642z',
                9:'124x144y-1184z',
                10:'128x340y-1143z',
                11:'139x146y-1182z',
                12:'13x294y-1163z',
                13:'13x70y-1197z',
                14:'150x343y-1139z',
                15:'151x1079y-501z',
                16:'156x147y-1180z',
                17:'156x998y-816z',
                18:'16x1000y-662z',
                19:'172x146y-1178z',
                20:'173x345y-1136z',
                21:'176x1004y-632z',
                22:'183x1158y-253z',
                23:'189x144y-1176z',
                24:'194x920y-744z',
                25:'196x345y-1132z',
                26:'19x24y-1199z',
                27:'19x81y-1197z',
                28:'1x35y-1199z',
                29:'206x140y-1173z',
                30:'208x1075y-490z',
                31:'220x344y-1128z',
                32:'230x1000y-621z',
                33:'243x916y-735z',
                34:'244x1149y-241z',
                35:'245x341y-1123z',
                36:'266x1067y-479z',
                37:'269x337y-1119z',
                38:'27x91y-1196z',
                39:'284x992y-611z',
                40:'293x909y-725z',
                41:'294x330y-1115z',
                42:'29x31y-1199z',
                43:'304x1137y-229z',
                44:'30x304y-1160z',
                45:'319x322y-1110z',
                46:'323x1056y-468z',
                47:'337x982y-601z',
                48:'343x313y-1106z',
                49:'343x899y-716z',
                50:'364x1122y-218z',
                51:'368x301y-1101z',
                52:'36x101y-1195z',
                53:'379x1042y-457z',
                54:'37x1079y-523z',
                55:'390x968y-590z',
                56:'392x288y-1096z',
                57:'393x886y-706z',
                58:'39x38y-1198z',
                59:'3x47y-1199z',
                60:'3x5y-1199z',
                61:'416x273y-1091z',
                62:'423x1103y-206z',
                63:'435x1025y-446z',
                64:'442x871y-696z',
                65:'443x952y-580z',
                66:'46x110y-1194z',
                67:'47x314y-1157z',
                68:'481x1081y-194z',
                69:'490x1005y-435z',
                70:'490x852y-687z',
                71:'495x932y-569z',
                72:'50x44y-1198z',
                73:'538x1056y-182z',
                74:'538x831y-677z',
                75:'544x981y-423z',
                76:'546x910y-559z',
                77:'56x118y-1192z',
                78:'584x807y-667z',
                79:'593x1028y-170z',
                80:'596x885y-548z',
                81:'597x955y-412z',
                82:'61x1166y-276z',
                83:'62x49y-1197z',
                84:'630x781y-657z',
                85:'645x857y-537z',
                86:'647x997y-158z',
                87:'648x926y-401z',
                88:'66x322y-1153z',
                89:'674x752y-647z',
                90:'68x125y-1191z',
                91:'692x826y-527z',
                92:'698x894y-390z',
                93:'69x1004y-652z',
                94:'700x963y-146z',
                95:'717x720y-636z',
                96:'738x792y-516z',
                97:'747x859y-378z',
                98:'74x52y-1196z',
                99:'750x926y-135z',
                100:'759x685y-626z',
                101:'782x756y-505z',
                102:'793x821y-367z',
                103:'798x887y-123z',
                104:'799x649y-616z',
                105:'7x59y-1198z',
                106:'81x132y-1189z',
                107:'824x717y-494z',
                108:'836x610y-606z',
                109:'838x781y-355z',
                110:'844x844y-111z',
                111:'865x676y-483z',
                112:'86x329y-1150z',
                113:'880x738y-344z',
                114:'888x800y-99z',
                115:'903x633y-472z',
                116:'920x693y-332z',
                117:'930x753y-87z',
                118:'94x1081y-512z',
                119:'958x646y-321z',
                120:'95x137y-1188z',
                121:'968x703y-75z'}

shot2three13004xi = {
                1:'0x1261y-312z',
                2:'0x12y-1299z',
                3:'0x25y-1299z',
                4:'1007x815y-94z',
                5:'102x1171y-554z',
                6:'1038x700y-348z',
                7:'103x148y-1287z',
                8:'1049x762y-81z',
                9:'115x363y-1242z',
                10:'118x153y-1285z',
                11:'12x16y-1299z',
                12:'132x1260y-287z',
                13:'133x1089y-695z',
                14:'134x156y-1283z',
                15:'139x368y-1238z',
                16:'14x318y-1260z',
                17:'14x76y-1297z',
                18:'151x158y-1281z',
                19:'163x372y-1234z',
                20:'164x1169y-543z',
                21:'168x1075y-879z',
                22:'169x159y-1279z',
                23:'186x158y-1276z',
                24:'187x374y-1230z',
                25:'18x1083y-717z',
                26:'191x1088y-684z',
                27:'198x1255y-274z',
                28:'1x38y-1299z',
                29:'205x156y-1274z',
                30:'210x997y-806z',
                31:'213x374y-1226z',
                32:'21x26y-1299z',
                33:'21x88y-1296z',
                34:'223x152y-1271z',
                35:'226x1164y-531z',
                36:'239x373y-1222z',
                37:'249x1083y-673z',
                38:'264x1245y-261z',
                39:'264x992y-796z',
                40:'265x370y-1217z',
                41:'288x1156y-519z',
                42:'292x365y-1212z',
                43:'29x99y-1295z',
                44:'307x1075y-662z',
                45:'318x358y-1208z',
                46:'318x985y-786z',
                47:'31x34y-1299z',
                48:'32x330y-1256z',
                49:'330x1232y-249z',
                50:'345x349y-1203z',
                51:'349x1144y-507z',
                52:'365x1063y-651z',
                53:'372x339y-1198z',
                54:'372x974y-775z',
                55:'395x1215y-236z',
                56:'398x326y-1193z',
                57:'39x109y-1294z',
                58:'40x1169y-566z',
                59:'411x1129y-495z',
                60:'423x1049y-640z',
                61:'425x312y-1188z',
                62:'425x960y-765z',
                63:'42x41y-1298z',
                64:'450x296y-1182z',
                65:'458x1195y-223z',
                66:'471x1110y-483z',
                67:'478x943y-754z',
                68:'480x1031y-628z',
                69:'49x119y-1293z',
                70:'4x51y-1298z',
                71:'4x6y-1299z',
                72:'51x340y-1253z',
                73:'521x1171y-210z',
                74:'531x1088y-471z',
                75:'531x923y-744z',
                76:'536x1010y-617z',
                77:'54x48y-1297z',
                78:'583x1144y-197z',
                79:'583x901y-733z',
                80:'589x1063y-459z',
                81:'591x986y-605z',
                82:'61x128y-1292z',
                83:'633x875y-722z',
                84:'643x1114y-185z',
                85:'646x1035y-447z',
                86:'646x958y-594z',
                87:'66x1263y-299z',
                88:'67x53y-1297z',
                89:'683x846y-711z',
                90:'698x928y-582z',
                91:'701x1080y-172z',
                92:'702x1003y-434z',
                93:'72x349y-1250z',
                94:'731x814y-701z',
                95:'74x136y-1290z',
                96:'750x895y-571z',
                97:'756x968y-422z',
                98:'758x1043y-159z',
                99:'75x1088y-706z',
                100:'777x780y-690z',
                101:'799x858y-559z',
                102:'809x931y-410z',
                103:'80x57y-1296z',
                104:'812x1003y-146z',
                105:'822x743y-679z',
                106:'847x819y-547z',
                107:'859x890y-397z',
                108:'865x703y-667z',
                109:'865x960y-133z',
                110:'88x143y-1289z',
                111:'893x777y-535z',
                112:'8x64y-1298z',
                113:'906x660y-656z',
                114:'908x846y-385z',
                115:'915x915y-120z',
                116:'937x732y-523z',
                117:'93x357y-1246z',
                118:'953x800y-373z',
                119:'962x866y-107z',
                120:'978x685y-511z',
                121:'997x751y-360z'}

shot2three14004xi = {
                1:'0x1358y-336z',
                2:'0x27y-1399z',
                3:'1009x789y-564z',
                4:'100x384y-1342z',
                5:'1027x862y-401z',
                6:'1036x933y-115z',
                7:'1053x738y-551z',
                8:'1074x809y-388z',
                9:'1085x878y-101z',
                10:'110x1261y-597z',
                11:'110x160y-1386z',
                12:'1118x754y-374z',
                13:'1130x821y-87z',
                14:'119x1151y-954z',
                15:'124x391y-1338z',
                16:'127x165y-1384z',
                17:'13x17y-1399z',
                18:'142x1357y-309z',
                19:'143x1173y-749z',
                20:'145x168y-1382z',
                21:'149x397y-1334z',
                22:'15x82y-1397z',
                23:'163x171y-1379z',
                24:'168x1075y-879z',
                25:'16x343y-1357z',
                26:'175x400y-1329z',
                27:'177x1259y-584z',
                28:'182x171y-1377z',
                29:'19x1167y-772z',
                30:'1x41y-1399z',
                31:'201x170y-1374z',
                32:'202x403y-1325z',
                33:'206x1172y-737z',
                34:'214x1351y-295z',
                35:'220x168y-1372z',
                36:'226x1074y-868z',
                37:'229x403y-1320z',
                38:'23x28y-1399z',
                39:'23x94y-1396z',
                40:'240x164y-1369z',
                41:'243x1254y-572z',
                42:'257x401y-1316z',
                43:'268x1166y-725z',
                44:'284x1069y-857z',
                45:'285x1341y-281z',
                46:'286x398y-1311z',
                47:'310x1245y-559z',
                48:'314x393y-1306z',
                49:'31x106y-1395z',
                50:'331x1158y-713z',
                51:'342x1060y-846z',
                52:'343x385y-1301z',
                53:'34x37y-1399z',
                54:'355x1327y-268z',
                55:'35x355y-1353z',
                56:'372x376y-1295z',
                57:'376x1232y-546z',
                58:'393x1145y-701z',
                59:'400x1049y-835z',
                60:'401x365y-1290z',
                61:'425x1309y-254z',
                62:'429x352y-1285z',
                63:'42x118y-1394z',
                64:'43x1259y-610z',
                65:'442x1216y-533z',
                66:'455x1130y-689z',
                67:'457x336y-1279z',
                68:'458x1034y-824z',
                69:'45x45y-1398z',
                70:'485x319y-1273z',
                71:'494x1287y-240z',
                72:'4x55y-1398z',
                73:'4x6y-1399z',
                74:'507x1196y-520z',
                75:'515x1016y-812z',
                76:'517x1110y-677z',
                77:'53x128y-1393z',
                78:'55x366y-1350z',
                79:'561x1262y-226z',
                80:'571x1172y-507z',
                81:'572x994y-801z',
                82:'577x1088y-664z',
                83:'58x51y-1397z',
                84:'627x970y-790z',
                85:'628x1232y-213z',
                86:'634x1145y-494z',
                87:'637x1062y-652z',
                88:'66x138y-1391z',
                89:'682x942y-778z',
                90:'692x1200y-199z',
                91:'695x1032y-640z',
                92:'696x1114y-481z',
                93:'71x1360y-322z',
                94:'72x57y-1396z',
                95:'735x911y-766z',
                96:'752x999y-627z',
                97:'755x1163y-185z',
                98:'756x1080y-468z',
                99:'77x376y-1346z',
                100:'787x877y-754z',
                101:'807x963y-615z',
                102:'80x146y-1389z',
                103:'815x1043y-455z',
                104:'816x1124y-171z',
                105:'81x1172y-761z',
                106:'837x840y-743z',
                107:'861x924y-602z',
                108:'86x61y-1395z',
                109:'871x1002y-441z',
                110:'875x1081y-157z',
                111:'885x800y-731z',
                112:'912x882y-589z',
                113:'925x958y-428z',
                114:'931x1034y-143z',
                115:'932x757y-719z',
                116:'95x154y-1388z',
                117:'962x837y-577z',
                118:'976x711y-707z',
                119:'977x911y-415z',
                120:'985x985y-129z',
                121:'9x69y-1398z'}

shot2three15004xi = {
                1:'0x1456y-360z',
                2:'0x29y-1499z',
                3:'101x165y-1487z',
                4:'1030x897y-618z',
                5:'1046x762y-757z',
                6:'1047x976y-444z',
                7:'1056x1056y-139z',
                8:'107x412y-1438z',
                9:'1081x845y-604z',
                10:'1100x923y-430z',
                11:'1110x1000y-124z',
                12:'1129x791y-590z',
                13:'1150x867y-415z',
                14:'1162x941y-109z',
                15:'118x1351y-640z',
                16:'118x171y-1485z',
                17:'1198x808y-401z',
                18:'1211x879y-94z',
                19:'127x1227y-1017z',
                20:'133x419y-1433z',
                21:'136x177y-1483z',
                22:'14x19y-1499z',
                23:'152x1454y-331z',
                24:'153x1257y-802z',
                25:'155x181y-1480z',
                26:'160x425y-1429z',
                27:'16x88y-1497z',
                28:'174x183y-1478z',
                29:'17x367y-1454z',
                30:'180x1152y-942z',
                31:'188x429y-1424z',
                32:'189x1349y-626z',
                33:'195x184y-1475z',
                34:'1x44y-1499z',
                35:'215x183y-1473z',
                36:'216x431y-1420z',
                37:'21x1250y-828z',
                38:'220x1255y-790z',
                39:'229x1448y-316z',
                40:'236x180y-1470z',
                41:'242x1150y-930z',
                42:'246x432y-1415z',
                43:'24x101y-1496z',
                44:'24x30y-1499z',
                45:'257x176y-1467z',
                46:'261x1343y-613z',
                47:'276x430y-1410z',
                48:'287x1250y-777z',
                49:'304x1145y-919z',
                50:'305x1437y-302z',
                51:'306x426y-1404z',
                52:'332x1334y-599z',
                53:'337x421y-1399z',
                54:'34x114y-1495z',
                55:'355x1240y-764z',
                56:'367x1136y-907z',
                57:'368x413y-1394z',
                58:'36x39y-1499z',
                59:'37x380y-1450z',
                60:'381x1422y-287z',
                61:'398x403y-1388z',
                62:'403x1320y-585z',
                63:'421x1227y-751z',
                64:'429x1124y-895z',
                65:'429x391y-1382z',
                66:'455x1402y-272z',
                67:'45x126y-1493z',
                68:'460x377y-1376z',
                69:'474x1303y-571z',
                70:'47x1349y-653z',
                71:'488x1210y-738z',
                72:'490x360y-1370z',
                73:'491x1108y-883z',
                74:'49x48y-1498z',
                75:'4x59y-1498z',
                76:'4x7y-1499z',
                77:'520x342y-1364z',
                78:'529x1379y-257z',
                79:'544x1281y-557z',
                80:'552x1088y-871z',
                81:'554x1190y-725z',
                82:'57x137y-1492z',
                83:'59x392y-1446z',
                84:'602x1352y-243z',
                85:'612x1256y-543z',
                86:'613x1066y-858z',
                87:'619x1165y-712z',
                88:'62x55y-1497z',
                89:'672x1039y-846z',
                90:'673x1320y-228z',
                91:'680x1227y-529z',
                92:'682x1137y-699z',
                93:'71x148y-1490z',
                94:'731x1009y-834z',
                95:'742x1285y-213z',
                96:'745x1106y-685z',
                97:'746x1194y-515z',
                98:'76x1457y-346z',
                99:'77x61y-1496z',
                100:'788x976y-821z',
                101:'806x1071y-672z',
                102:'809x1246y-198z',
                103:'810x1157y-501z',
                104:'83x403y-1442z',
                105:'843x940y-808z',
                106:'85x157y-1489z',
                107:'865x1032y-658z',
                108:'873x1117y-487z',
                109:'875x1204y-183z',
                110:'87x1255y-815z',
                111:'897x900y-796z',
                112:'922x990y-645z',
                113:'92x65y-1495z',
                114:'933x1074y-473z',
                115:'937x1158y-168z',
                116:'949x857y-783z',
                117:'978x945y-631z',
                118:'991x1027y-459z',
                119:'998x1108y-153z',
                120:'998x811y-770z',
                121:'9x73y-1498z'}

shot2three16004xi = {
                1:'0x1553y-384z',
                2:'0x31y-1599z',
                3:'1000x1235y-180z',
                4:'1012x914y-835z',
                5:'1043x1008y-673z',
                6:'1058x1095y-489z',
                7:'1064x1182y-164z',
                8:'1065x865y-822z',
                9:'108x176y-1586z',
                10:'1099x956y-659z',
                11:'10x78y-1598z',
                12:'1115x813y-808z',
                13:'1117x1042y-474z',
                14:'1126x1126y-148z',
                15:'1153x902y-644z',
                16:'115x439y-1534z',
                17:'1174x985y-459z',
                18:'1184x1066y-132z',
                19:'1204x844y-630z',
                20:'1227x925y-443z',
                21:'1240x1004y-116z',
                22:'126x1441y-682z',
                23:'126x183y-1584z',
                24:'1278x862y-428z',
                25:'1291x938y-100z',
                26:'135x1304y-1081z',
                27:'142x447y-1529z',
                28:'145x189y-1582z',
                29:'15x20y-1599z',
                30:'163x1551y-353z',
                31:'164x1341y-856z',
                32:'165x193y-1579z',
                33:'171x453y-1524z',
                34:'17x93y-1597z',
                35:'186x195y-1576z',
                36:'18x392y-1551z',
                37:'192x1229y-1005z',
                38:'1x47y-1599z',
                39:'200x458y-1519z',
                40:'202x1439y-668z',
                41:'208x196y-1574z',
                42:'22x1333y-883z',
                43:'230x195y-1571z',
                44:'231x460y-1514z',
                45:'235x1339y-842z',
                46:'244x1544y-337z',
                47:'252x192y-1568z',
                48:'258x1227y-993z',
                49:'262x460y-1509z',
                50:'26x108y-1596z',
                51:'26x32y-1599z',
                52:'275x187y-1564z',
                53:'278x1433y-653z',
                54:'294x459y-1504z',
                55:'307x1333y-829z',
                56:'325x1221y-980z',
                57:'325x1532y-322z',
                58:'326x455y-1498z',
                59:'354x1423y-639z',
                60:'359x449y-1492z',
                61:'36x122y-1594z',
                62:'378x1323y-815z',
                63:'38x42y-1598z',
                64:'391x1212y-967z',
                65:'392x441y-1487z',
                66:'406x1516y-306z',
                67:'40x406y-1547z',
                68:'425x430y-1481z',
                69:'430x1408y-624z',
                70:'450x1309y-801z',
                71:'458x1199y-954z',
                72:'458x417y-1474z',
                73:'486x1496y-290z',
                74:'48x135y-1593z',
                75:'491x402y-1468z',
                76:'505x1390y-609z',
                77:'50x1439y-697z',
                78:'521x1291y-787z',
                79:'523x384y-1462z',
                80:'524x1182y-942z',
                81:'52x51y-1598z',
                82:'554x364y-1455z',
                83:'564x1471y-275z',
                84:'580x1367y-594z',
                85:'589x1161y-929z',
                86:'591x1269y-773z',
                87:'5x63y-1598z',
                88:'5x7y-1599z',
                89:'61x147y-1592z',
                90:'63x418y-1542z',
                91:'642x1442y-259z',
                92:'653x1340y-580z',
                93:'654x1137y-916z',
                94:'660x1243y-759z',
                95:'67x59y-1597z',
                96:'717x1108y-902z',
                97:'717x1408y-243z',
                98:'725x1309y-565z',
                99:'728x1213y-745z',
                100:'75x158y-1590z',
                101:'779x1077y-889z',
                102:'791x1371y-227z',
                103:'795x1180y-731z',
                104:'796x1274y-550z',
                105:'81x1554y-369z',
                106:'82x65y-1596z',
                107:'840x1041y-876z',
                108:'860x1142y-717z',
                109:'863x1330y-211z',
                110:'864x1235y-535z',
                111:'88x430y-1538z',
                112:'899x1002y-862z',
                113:'91x167y-1588z',
                114:'923x1101y-702z',
                115:'92x1339y-869z',
                116:'931x1192y-520z',
                117:'933x1284y-195z',
                118:'957x960y-849z',
                119:'984x1056y-688z',
                120:'996x1145y-504z',
                121:'99x70y-1595z'}

shot2three17004xi = {
                1:'0x1650y-408z',
                2:'0x33y-1699z',
                3:'1017x1020y-902z',
                4:'1045x1122y-731z',
                5:'1058x1217y-536z',
                6:'105x74y-1695z',
                7:'1063x1312y-191z',
                8:'1075x971y-887z',
                9:'1108x1071y-716z',
                10:'1124x1164y-520z',
                11:'1131x1256y-174z',
                12:'1131x919y-873z',
                13:'115x187y-1685z',
                14:'1168x1016y-700z',
                15:'1185x864y-858z',
                16:'1187x1107y-504z',
                17:'1196x1196y-157z',
                18:'11x83y-1697z',
                19:'1225x958y-685z',
                20:'122x467y-1629z',
                21:'1247x1046y-487z',
                22:'1259x1133y-140z',
                23:'1279x896y-669z',
                24:'1304x982y-471z',
                25:'1317x1067y-123z',
                26:'133x1531y-725z',
                27:'134x194y-1683z',
                28:'1357x915y-455z',
                29:'1372x997y-106z',
                30:'142x1381y-1145z',
                31:'151x475y-1625z',
                32:'154x200y-1680z',
                33:'16x21y-1699z',
                34:'173x1648y-375z',
                35:'174x1425y-909z',
                36:'176x205y-1678z',
                37:'181x482y-1620z',
                38:'18x99y-1696z',
                39:'198x207y-1675z',
                40:'19x416y-1647z',
                41:'1x50y-1699z',
                42:'204x1306y-1068z',
                43:'213x486y-1614z',
                44:'214x1529y-710z',
                45:'221x208y-1672z',
                46:'23x1417y-938z',
                47:'244x207y-1669z',
                48:'245x489y-1609z',
                49:'250x1423y-895z',
                50:'259x1641y-359z',
                51:'268x204y-1666z',
                52:'275x1304y-1055z',
                53:'279x489y-1603z',
                54:'27x115y-1695z',
                55:'28x34y-1699z',
                56:'292x199y-1662z',
                57:'296x1523y-694z',
                58:'312x488y-1598z',
                59:'326x1416y-881z',
                60:'345x1298y-1041z',
                61:'346x1628y-342z',
                62:'347x483y-1592z',
                63:'377x1512y-679z',
                64:'382x477y-1586z',
                65:'38x129y-1694z',
                66:'402x1406y-866z',
                67:'416x1288y-1028z',
                68:'417x468y-1579z',
                69:'41x45y-1698z',
                70:'42x431y-1643z',
                71:'431x1611y-325z',
                72:'452x457y-1573z',
                73:'457x1496y-663z',
                74:'478x1391y-851z',
                75:'486x1274y-1014z',
                76:'487x443y-1567z',
                77:'516x1589y-309z',
                78:'51x143y-1693z',
                79:'521x427y-1560z',
                80:'537x1476y-647z',
                81:'53x1529y-740z',
                82:'553x1372y-837z',
                83:'555x408y-1553z',
                84:'556x1256y-1000z',
                85:'55x54y-1698z',
                86:'589x387y-1546z',
                87:'5x67y-1698z',
                88:'5x8y-1699z',
                89:'600x1563y-292z',
                90:'616x1452y-632z',
                91:'626x1234y-987z',
                92:'628x1348y-822z',
                93:'65x156y-1691z',
                94:'67x445y-1639z',
                95:'682x1532y-275z',
                96:'694x1208y-973z',
                97:'694x1423y-616z',
                98:'701x1321y-807z',
                99:'71x62y-1697z',
                100:'762x1178y-959z',
                101:'762x1497y-258z',
                102:'771x1391y-600z',
                103:'773x1289y-792z',
                104:'80x167y-1689z',
                105:'828x1144y-945z',
                106:'841x1457y-241z',
                107:'844x1253y-777z',
                108:'845x1353y-584z',
                109:'86x1651y-392z',
                110:'87x69y-1696z',
                111:'893x1106y-931z',
                112:'913x1214y-762z',
                113:'917x1413y-225z',
                114:'918x1312y-568z',
                115:'94x456y-1634z',
                116:'956x1065y-916z',
                117:'97x178y-1687z',
                118:'981x1170y-746z',
                119:'989x1266y-552z',
                120:'98x1423y-924z',
                121:'991x1364y-208z'}
       
shot2three18004xi = {
                1:'0x1747y-432z',
                2:'0x35y-1799z',
                3:'1012x1128y-970z',
                4:'1038x1239y-790z',
                5:'103x188y-1787z',
                6:'1048x1341y-585z',
                7:'104x1507y-978z',
                8:'1050x1445y-220z',
                9:'1076x1080y-955z',
                10:'1107x1188y-774z',
                11:'111x79y-1794z',
                12:'1120x1289y-567z',
                13:'1125x1389y-202z',
                14:'1139x1028y-940z',
                15:'1173x1134y-758z',
                16:'1190x1232y-550z',
                17:'1198x1330y-184z',
                18:'1198x973y-924z',
                19:'11x88y-1797z',
                20:'122x198y-1784z',
                21:'1237x1076y-741z',
                22:'1255x915y-909z',
                23:'1257x1172y-533z',
                24:'1267x1267y-166z',
                25:'1297x1014y-725z',
                26:'129x494y-1725z',
                27:'1320x1108y-516z',
                28:'1333x1200y-148z',
                29:'1354x949y-708z',
                30:'1381x1040y-499z',
                31:'1395x1129y-130z',
                32:'141x1621y-768z',
                33:'142x206y-1782z',
                34:'1437x969y-481z',
                35:'1453x1055y-112z',
                36:'150x1458y-1208z',
                37:'160x503y-1720z',
                38:'164x212y-1779z',
                39:'17x23y-1799z',
                40:'183x1745y-397z',
                41:'184x1509y-963z',
                42:'186x217y-1777z',
                43:'192x510y-1715z',
                44:'19x105y-1796z',
                45:'1x53y-1799z',
                46:'209x220y-1774z',
                47:'20x441y-1744z',
                48:'216x1383y-1131z',
                49:'225x515y-1709z',
                50:'227x1619y-752z',
                51:'234x220y-1770z',
                52:'258x219y-1767z',
                53:'25x1500y-993z',
                54:'260x518y-1704z',
                55:'264x1506y-948z',
                56:'275x1737y-380z',
                57:'284x216y-1764z',
                58:'291x1380y-1117z',
                59:'295x518y-1698z',
                60:'29x121y-1795z',
                61:'29x36y-1799z',
                62:'309x211y-1760z',
                63:'313x1612y-735z',
                64:'331x516y-1692z',
                65:'345x1500y-932z',
                66:'365x1374y-1103z',
                67:'366x1724y-362z',
                68:'367x512y-1685z',
                69:'399x1601y-719z',
                70:'404x505y-1679z',
                71:'41x137y-1794z',
                72:'426x1488y-917z',
                73:'43x47y-1798z',
                74:'440x1363y-1088z',
                75:'441x496y-1672z',
                76:'457x1706y-344z',
                77:'45x457y-1740z',
                78:'478x484y-1666z',
                79:'484x1584y-702z',
                80:'506x1473y-901z',
                81:'515x1349y-1074z',
                82:'515x469y-1659z',
                83:'546x1683y-327z',
                84:'54x151y-1792z',
                85:'552x452y-1652z',
                86:'569x1563y-686z',
                87:'56x1619y-784z',
                88:'586x1452y-886z',
                89:'588x432y-1645z',
                90:'589x1330y-1059z',
                91:'59x57y-1798z',
                92:'5x71y-1798z',
                93:'5x8y-1799z',
                94:'624x410y-1637z',
                95:'635x1655y-309z',
                96:'652x1538y-669z',
                97:'663x1306y-1045z',
                98:'665x1428y-870z',
                99:'69x165y-1791z',
                100:'71x471y-1735z',
                101:'722x1622y-291z',
                102:'735x1279y-1030z',
                103:'735x1507y-652z',
                104:'742x1399y-854z',
                105:'75x66y-1797z',
                106:'807x1247y-1015z',
                107:'807x1585y-273z',
                108:'816x1472y-635z',
                109:'819x1365y-838z',
                110:'85x177y-1789z',
                111:'877x1211y-1000z',
                112:'890x1542y-256z',
                113:'894x1327y-822z',
                114:'895x1433y-618z',
                115:'91x1749y-415z',
                116:'93x73y-1796z',
                117:'945x1171y-985z',
                118:'967x1285y-806z',
                119:'971x1496y-238z',
                120:'972x1389y-602z',
                121:'99x483y-1730z'}

shot2three19004xi = {
                1:'0x1844y-456z',
                2:'0x37y-1899z',
                3:'1021x1356y-851z',
                4:'1025x1579y-251z',
                5:'1027x1466y-635z',
                6:'105x510y-1827z',
                7:'1068x1190y-1024z',
                8:'108x199y-1886z',
                9:'1096x1308y-834z',
                10:'1106x1415y-617z',
                11:'1108x1525y-232z',
                12:'110x1590y-1032z',
                13:'1136x1140y-1008z',
                14:'1169x1254y-817z',
                15:'117x83y-1894z',
                16:'1182x1360y-599z',
                17:'1188x1467y-213z',
                18:'1202x1086y-992z',
                19:'1238x1197y-800z',
                20:'1256x1301y-581z',
                21:'1264x1404y-194z',
                22:'1265x1027y-976z',
                23:'129x209y-1884z',
                24:'12x93y-1897z',
                25:'1305x1136y-783z',
                26:'1325x965y-959z',
                27:'1327x1237y-563z',
                28:'1337x1337y-176z',
                29:'1369x1071y-765z',
                30:'136x522y-1821z',
                31:'1394x1169y-545z',
                32:'1407x1266y-157z',
                33:'1430x1002y-748z',
                34:'1457x1098y-526z',
                35:'1472x1192y-138z',
                36:'149x1711y-811z',
                37:'150x217y-1881z',
                38:'1517x1023y-508z',
                39:'1534x1114y-119z',
                40:'158x1534y-1272z',
                41:'169x531y-1816z',
                42:'173x224y-1878z',
                43:'18x24y-1899z',
                44:'193x1842y-419z',
                45:'194x1593y-1016z',
                46:'196x229y-1875z',
                47:'1x56y-1899z',
                48:'203x538y-1810z',
                49:'20x111y-1896z',
                50:'21x465y-1841z',
                51:'221x232y-1872z',
                52:'228x1460y-1194z',
                53:'238x544y-1804z',
                54:'240x1709y-793z',
                55:'247x233y-1869z',
                56:'26x1584y-1048z',
                57:'273x232y-1865z',
                58:'274x546y-1798z',
                59:'279x1590y-1000z',
                60:'290x1834y-401z',
                61:'299x228y-1862z',
                62:'307x1457y-1179z',
                63:'311x547y-1792z',
                64:'31x128y-1895z',
                65:'31x38y-1899z',
                66:'326x223y-1858z',
                67:'330x1702y-776z',
                68:'349x545y-1786z',
                69:'364x1583y-984z',
                70:'386x1450y-1164z',
                71:'386x1820y-382z',
                72:'388x540y-1779z',
                73:'421x1690y-759z',
                74:'427x533y-1772z',
                75:'43x145y-1893z',
                76:'449x1571y-968z',
                77:'465x1439y-1149z',
                78:'466x523y-1765z',
                79:'46x50y-1898z',
                80:'47x482y-1837z',
                81:'482x1801y-364z',
                82:'505x511y-1758z',
                83:'511x1672y-741z',
                84:'534x1554y-951z',
                85:'544x1424y-1134z',
                86:'544x495y-1751z',
                87:'577x1776y-345z',
                88:'57x160y-1892z',
                89:'583x477y-1744z',
                90:'59x1708y-828z',
                91:'600x1650y-724z',
                92:'618x1533y-935z',
                93:'621x456y-1736z',
                94:'622x1403y-1118z',
                95:'62x61y-1897z',
                96:'658x433y-1728z',
                97:'670x1747y-326z',
                98:'689x1623y-706z',
                99:'6x75y-1898z',
                100:'6x9y-1899z',
                101:'700x1379y-1103z',
                102:'702x1507y-918z',
                103:'72x174y-1890z',
                104:'75x497y-1832z',
                105:'762x1712y-307z',
                106:'776x1350y-1087z',
                107:'776x1591y-688z',
                108:'784x1476y-902z',
                109:'79x70y-1897z',
                110:'852x1316y-1072z',
                111:'852x1673y-289z',
                112:'861x1554y-671z',
                113:'865x1441y-885z',
                114:'90x187y-1888z',
                115:'926x1279y-1056z',
                116:'940x1628y-270z',
                117:'944x1401y-868z',
                118:'945x1513y-653z',
                119:'96x1846y-438z',
                120:'98x77y-1895z',
                121:'998x1237y-1040z'}

shot2three20004xi = {
                1:'0x1941y-480z',
                2:'0x39y-1999z',
                3:'101x1943y-461z',
                4:'103x81y-1995z',
                5:'1051x1302y-1095z',
                6:'1075x1428y-896z',
                7:'1079x1662y-264z',
                8:'1081x1543y-668z',
                9:'111x537y-1923z',
                10:'1124x1253y-1078z',
                11:'114x209y-1985z',
                12:'1154x1376y-878z',
                13:'1164x1490y-650z',
                14:'1166x1605y-244z',
                15:'116x1674y-1087z',
                16:'1196x1200y-1061z',
                17:'1230x1321y-860z',
                18:'123x87y-1994z',
                19:'1245x1432y-631z',
                20:'1250x1544y-225z',
                21:'1265x1143y-1044z',
                22:'1304x1260y-842z',
                23:'1322x1369y-612z',
                24:'1331x1081y-1027z',
                25:'1331x1478y-205z',
                26:'135x220y-1983z',
                27:'1374x1196y-824z',
                28:'1394x1016y-1010z',
                29:'1396x1302y-592z',
                30:'13x98y-1997z',
                31:'1408x1408y-185z',
                32:'143x549y-1917z',
                33:'1441x1127y-806z',
                34:'1467x1231y-573z',
                35:'1481x1333y-165z',
                36:'1505x1055y-787z',
                37:'1534x1156y-554z',
                38:'1550x1255y-145z',
                39:'157x1801y-853z',
                40:'158x229y-1980z',
                41:'1597x1077y-535z',
                42:'1614x1173y-125z',
                43:'166x1611y-1336z',
                44:'178x559y-1911z',
                45:'182x236y-1977z',
                46:'19x25y-1999z',
                47:'1x59y-1999z',
                48:'203x1939y-441z',
                49:'205x1676y-1070z',
                50:'207x241y-1974z',
                51:'214x567y-1905z',
                52:'22x117y-1996z',
                53:'22x490y-1938z',
                54:'233x244y-1971z',
                55:'240x1536y-1256z',
                56:'251x572y-1899z',
                57:'252x1799y-835z',
                58:'260x245y-1967z',
                59:'287x244y-1964z',
                60:'289x575y-1893z',
                61:'28x1667y-1104z',
                62:'294x1674y-1053z',
                63:'305x1930y-422z',
                64:'315x240y-1960z',
                65:'323x1534y-1241z',
                66:'328x576y-1886z',
                67:'32x135y-1995z',
                68:'33x40y-1999z',
                69:'343x234y-1956z',
                70:'348x1791y-817z',
                71:'368x574y-1880z',
                72:'383x1666y-1036z',
                73:'406x1527y-1225z',
                74:'407x1916y-402z',
                75:'408x569y-1873z',
                76:'443x1778y-799z',
                77:'449x561y-1866z',
                78:'45x152y-1993z',
                79:'473x1654y-1019z',
                80:'489x1515y-1209z',
                81:'48x52y-1998z',
                82:'490x551y-1858z',
                83:'508x1896y-383z',
                84:'50x507y-1933z',
                85:'531x538y-1851z',
                86:'538x1760y-780z',
                87:'562x1636y-1002z',
                88:'572x1499y-1193z',
                89:'573x521y-1843z',
                90:'607x1870y-363z',
                91:'60x168y-1991z',
                92:'613x502y-1835z',
                93:'62x1798y-871z',
                94:'632x1737y-762z',
                95:'651x1614y-984z',
                96:'654x480y-1827z',
                97:'655x1477y-1177z',
                98:'65x64y-1997z',
                99:'693x456y-1819z',
                100:'6x79y-1998z',
                101:'6x9y-1999z',
                102:'706x1839y-343z',
                103:'725x1708y-743z',
                104:'736x1451y-1161z',
                105:'738x1586y-967z',
                106:'76x183y-1990z',
                107:'79x523y-1928z',
                108:'802x1802y-324z',
                109:'817x1421y-1145z',
                110:'817x1675y-725z',
                111:'825x1554y-949z',
                112:'83x73y-1996z',
                113:'897x1386y-1128z',
                114:'897x1761y-304z',
                115:'907x1636y-706z',
                116:'910x1517y-932z',
                117:'94x197y-1987z',
                118:'974x1346y-1112z',
                119:'989x1714y-284z',
                120:'993x1475y-914z',
                121:'995x1592y-687z'}         


shot2three21004xi = {
                1:'0x2038y-504z',
                2:'0x41y-2099z',
                3:'1023x1413y-1167z',
                4:'1039x1800y-298z',
                5:'1043x1548y-960z',
                6:'1044x1672y-722z',
                7:'106x2040y-484z',
                8:'108x85y-2095z',
                9:'1103x1367y-1150z',
                10:'1128x1499y-941z',
                11:'1133x1745y-278z',
                12:'1135x1621y-702z',
                13:'116x564y-2019z',
                14:'1181x1316y-1132z',
                15:'120x220y-2084z',
                16:'1211x1445y-922z',
                17:'1222x1564y-682z',
                18:'1225x1686y-257z',
                19:'122x1758y-1141z',
                20:'1256x1260y-1114z',
                21:'1292x1387y-903z',
                22:'129x92y-2093z',
                23:'1307x1503y-662z',
                24:'1313x1621y-236z',
                25:'1328x1200y-1096z',
                26:'1369x1323y-884z',
                27:'1388x1438y-642z',
                28:'1397x1552y-215z',
                29:'1398x1136y-1078z',
                30:'13x103y-2097z',
                31:'142x231y-2082z',
                32:'1443x1256y-865z',
                33:'1464x1067y-1060z',
                34:'1466x1367y-622z',
                35:'1478x1478y-194z',
                36:'1513x1184y-846z',
                37:'151x577y-2013z',
                38:'1541x1293y-602z',
                39:'1555x1400y-173z',
                40:'1580x1107y-827z',
                41:'1611x1214y-582z',
                42:'1627x1318y-152z',
                43:'165x1891y-896z',
                44:'166x240y-2079z',
                45:'1677x1131y-562z',
                46:'1695x1231y-131z',
                47:'174x1688y-1399z',
                48:'187x587y-2007z',
                49:'191x248y-2076z',
                50:'1x62y-2099z',
                51:'20x26y-2099z',
                52:'214x2036y-464z',
                53:'215x1760y-1124z',
                54:'217x253y-2073z',
                55:'224x595y-2001z',
                56:'23x123y-2096z',
                57:'244x256y-2069z',
                58:'24x514y-2035z',
                59:'252x1613y-1319z',
                60:'263x601y-1994z',
                61:'265x1889y-877z',
                62:'273x257y-2066z',
                63:'29x1750y-1159z',
                64:'301x256y-2062z',
                65:'303x604y-1988z',
                66:'309x1758y-1106z',
                67:'321x2027y-443z',
                68:'331x252y-2058z',
                69:'339x1611y-1303z',
                70:'344x605y-1981z',
                71:'34x142y-2094z',
                72:'34x42y-2099z',
                73:'361x246y-2053z',
                74:'365x1881y-858z',
                75:'386x602y-1974z',
                76:'403x1750y-1088z',
                77:'426x1603y-1286z',
                78:'427x2012y-422z',
                79:'429x597y-1966z',
                80:'465x1867y-839z',
                81:'472x589y-1959z',
                82:'47x160y-2093z',
                83:'497x1737y-1070z',
                84:'514x1591y-1270z',
                85:'515x578y-1951z',
                86:'51x55y-2098z',
                87:'52x533y-2030z',
                88:'533x1990y-402z',
                89:'558x565y-1943z',
                90:'565x1848y-819z',
                91:'590x1718y-1052z',
                92:'601x1573y-1253z',
                93:'601x548y-1935z',
                94:'638x1963y-381z',
                95:'63x177y-2091z',
                96:'644x528y-1927z',
                97:'65x1888y-915z',
                98:'664x1824y-800z',
                99:'683x1695y-1033z',
                100:'686x505y-1919z',
                101:'687x1551y-1236z',
                102:'68x67y-2097z',
                103:'6x10y-2099z',
                104:'6x83y-2098z',
                105:'728x478y-1910z',
                106:'741x1931y-361z',
                107:'761x1794y-780z',
                108:'773x1524y-1219z',
                109:'775x1666y-1015z',
                110:'80x193y-2089z',
                111:'83x549y-2025z',
                112:'842x1893y-340z',
                113:'857x1759y-761z',
                114:'858x1492y-1202z',
                115:'866x1632y-997z',
                116:'88x77y-2096z',
                117:'941x1455y-1185z',
                118:'942x1849y-319z',
                119:'952x1718y-741z',
                120:'956x1593y-978z',
                121:'99x207y-2087z'}

shot2three22004xi = {
                1:'0x2135y-528z',
                2:'1001x1668y-1025z',
                3:'104x217y-2186z',
                4:'1072x1481y-1223z',
                5:'1088x1885y-313z',
                6:'1093x1622y-1005z',
                7:'1094x1751y-756z',
                8:'112x2137y-507z',
                9:'113x90y-2195z',
                10:'1156x1432y-1204z',
                11:'1182x1571y-986z',
                12:'1187x1828y-291z',
                13:'1189x1698y-735z',
                14:'122x591y-2115z',
                15:'1237x1378y-1186z',
                16:'1269x1514y-966z',
                17:'126x230y-2184z',
                18:'127x1842y-1196z',
                19:'1280x1639y-715z',
                20:'1283x1766y-269z',
                21:'1316x1320y-1167z',
                22:'1353x1453y-946z',
                23:'1369x1575y-694z',
                24:'136x96y-2193z',
                25:'1375x1698y-247z',
                26:'1392x1257y-1149z',
                27:'1434x1386y-926z',
                28:'1454x1506y-673z',
                29:'1464x1190y-1130z',
                30:'1464x1626y-225z',
                31:'149x242y-2181z',
                32:'14x108y-2197z',
                33:'1512x1315y-906z',
                34:'1534x1118y-1111z',
                35:'1536x1432y-652z',
                36:'1548x1548y-203z',
                37:'1585x1240y-886z',
                38:'158x604y-2109z',
                39:'1614x1354y-631z',
                40:'1629x1467y-181z',
                41:'1655x1160y-866z',
                42:'1688x1272y-610z',
                43:'1705x1380y-160z',
                44:'173x1981y-939z',
                45:'174x1688y-1399z',
                46:'174x252y-2178z',
                47:'1757x1185y-588z',
                48:'1776x1290y-138z',
                49:'196x615y-2103z',
                50:'1x65y-2199z',
                51:'200x259y-2175z',
                52:'20x28y-2199z',
                53:'224x2133y-486z',
                54:'225x1844y-1177z',
                55:'228x265y-2171z',
                56:'235x623y-2096z',
                57:'24x129y-2196z',
                58:'256x268y-2168z',
                59:'25x539y-2132z',
                60:'264x1690y-1382z',
                61:'276x629y-2089z',
                62:'278x1979y-919z',
                63:'286x269y-2164z',
                64:'316x268y-2160z',
                65:'318x633y-2082z',
                66:'31x1834y-1214z',
                67:'323x1841y-1158z',
                68:'336x2123y-464z',
                69:'347x264y-2156z',
                70:'355x1687y-1365z',
                71:'361x633y-2075z',
                72:'36x149y-2194z',
                73:'36x44y-2199z',
                74:'378x258y-2151z',
                75:'383x1970y-899z',
                76:'404x631y-2068z',
                77:'422x1833y-1140z',
                78:'447x1680y-1348z',
                79:'448x2107y-443z',
                80:'449x626y-2060z',
                81:'487x1956y-878z',
                82:'494x617y-2052z',
                83:'50x167y-2193z',
                84:'520x1819y-1121z',
                85:'538x1667y-1330z',
                86:'539x606y-2044z',
                87:'53x58y-2198z',
                88:'558x2085y-421z',
                89:'55x558y-2127z',
                90:'585x591y-2036z',
                91:'592x1936y-858z',
                92:'618x1800y-1102z',
                93:'629x1648y-1313z',
                94:'630x574y-2028z',
                95:'668x2057y-399z',
                96:'66x185y-2191z',
                97:'675x553y-2019z',
                98:'695x1911y-838z',
                99:'69x1978y-958z',
                100:'716x1775y-1083z',
                101:'719x529y-2010z',
                102:'720x1625y-1295z',
                103:'72x70y-2197z',
                104:'762x501y-2001z',
                105:'776x2023y-378z',
                106:'797x1879y-818z',
                107:'7x10y-2199z',
                108:'7x87y-2198z',
                109:'810x1597y-1277z',
                110:'812x1745y-1064z',
                111:'84x202y-2189z',
                112:'87x575y-2121z',
                113:'882x1983y-356z',
                114:'898x1842y-797z',
                115:'899x1563y-1259z',
                116:'89x1757y-1480z',
                117:'908x1709y-1044z',
                118:'92x81y-2196z',
                119:'986x1524y-1241z',
                120:'987x1937y-334z',
                121:'997x1800y-777z'}

shot2three23004xi = {
                1:'0x2232y-552z',
                2:'1031x1594y-1297z',
                3:'1032x2025y-350z',
                4:'1043x1881y-812z',
                5:'1047x1744y-1071z',
                6:'109x227y-2286z',
                7:'1121x1548y-1278z',
                8:'1138x1971y-327z',
                9:'1142x1696y-1051z',
                10:'1144x1831y-790z',
                11:'117x2234y-530z',
                12:'118x94y-2294z',
                13:'1208x1497y-1259z',
                14:'1236x1642y-1030z',
                15:'1241x1911y-304z',
                16:'1243x1775y-769z',
                17:'127x618y-2211z',
                18:'1293x1441y-1240z',
                19:'131x241y-2283z',
                20:'1327x1583y-1010z',
                21:'1339x1714y-747z',
                22:'133x1925y-1250z',
                23:'1341x1846y-281z',
                24:'1376x1380y-1220z',
                25:'1415x1519y-989z',
                26:'142x101y-2293z',
                27:'1431x1647y-725z',
                28:'1438x1776y-258z',
                29:'1455x1314y-1201z',
                30:'1499x1449y-968z',
                31:'1521x1575y-703z',
                32:'1530x1700y-236z',
                33:'1531x1244y-1181z',
                34:'156x253y-2280z',
                35:'1580x1375y-947z',
                36:'15x113y-2297z',
                37:'1603x1169y-1161z',
                38:'1606x1498y-681z',
                39:'1619x1619y-213z',
                40:'1658x1296y-926z',
                41:'165x631y-2205z',
                42:'1687x1416y-659z',
                43:'1703x1533y-190z',
                44:'1731x1213y-905z',
                45:'1764x1329y-637z',
                46:'1782x1443y-167z',
                47:'181x2072y-981z',
                48:'182x1765y-1463z',
                49:'182x263y-2277z',
                50:'1837x1239y-615z',
                51:'1857x1349y-144z',
                52:'1x68y-2298z',
                53:'204x643y-2198z',
                54:'209x271y-2274z',
                55:'21x29y-2299z',
                56:'234x2230y-508z',
                57:'235x1928y-1231z',
                58:'238x277y-2270z',
                59:'246x652y-2191z',
                60:'25x135y-2295z',
                61:'268x281y-2266z',
                62:'26x563y-2229z',
                63:'277x1767y-1445z',
                64:'288x658y-2184z',
                65:'290x2069y-960z',
                66:'299x282y-2262z',
                67:'32x1917y-1269z',
                68:'330x280y-2258z',
                69:'332x662y-2177z',
                70:'338x1925y-1211z',
                71:'351x2220y-485z',
                72:'362x276y-2254z',
                73:'372x1764y-1427z',
                74:'377x662y-2169z',
                75:'37x155y-2294z',
                76:'38x46y-2299z',
                77:'395x270y-2249z',
                78:'400x2060y-939z',
                79:'423x660y-2162z',
                80:'441x1916y-1191z',
                81:'467x1756y-1409z',
                82:'468x2203y-463z',
                83:'469x654y-2154z',
                84:'510x2045y-918z',
                85:'516x646y-2146z',
                86:'52x175y-2292z',
                87:'544x1902y-1172z',
                88:'563x1742y-1391z',
                89:'564x634y-2137z',
                90:'56x60y-2298z',
                91:'57x583y-2223z',
                92:'584x2180y-440z',
                93:'611x618y-2129z',
                94:'619x2025y-897z',
                95:'647x1882y-1152z',
                96:'658x1723y-1372z',
                97:'659x600y-2120z',
                98:'698x2150y-418z',
                99:'69x194y-2290z',
                100:'705x578y-2111z',
                101:'727x1998y-876z',
                102:'72x2068y-1002z',
                103:'748x1856y-1132z',
                104:'752x553y-2101z',
                105:'753x1699y-1354z',
                106:'75x73y-2297z',
                107:'797x524y-2092z',
                108:'7x11y-2299z',
                109:'7x91y-2298z',
                110:'811x2115y-395z',
                111:'834x1965y-855z',
                112:'847x1669y-1335z',
                113:'849x1824y-1112z',
                114:'88x211y-2288z',
                115:'91x602y-2217z',
                116:'923x2073y-372z',
                117:'939x1926y-833z',
                118:'93x1833y-1545z',
                119:'940x1634y-1316z',
                120:'949x1787y-1092z',
                121:'96x85y-2296z'}

shot2three24004xi = {
                1:'0x2329y-577z',
                2:'100x88y-2396z',
                3:'1076x1663y-1354z',
                4:'1076x2113y-365z',
                5:'1088x1963y-847z',
                6:'1092x1820y-1118z',
                7:'113x237y-2385z',
                8:'1169x1615y-1334z',
                9:'1187x2057y-341z',
                10:'1192x1770y-1097z',
                11:'1194x1911y-825z',
                12:'122x2332y-553z',
                13:'124x98y-2394z',
                14:'1261x1562y-1314z',
                15:'1290x1714y-1075z',
                16:'1295x1995y-317z',
                17:'1297x1852y-802z',
                18:'133x645y-2307z',
                19:'1349x1504y-1294z',
                20:'137x251y-2382z',
                21:'1384x1652y-1054z',
                22:'1397x1788y-780z',
                23:'139x2009y-1304z',
                24:'1400x1927y-293z',
                25:'1435x1440y-1273z',
                26:'1476x1585y-1032z',
                27:'148x105y-2393z',
                28:'1494x1718y-757z',
                29:'1500x1853y-270z',
                30:'1518x1371y-1253z',
                31:'1564x1512y-1010z',
                32:'1587x1643y-734z',
                33:'1597x1774y-246z',
                34:'1598x1298y-1233z',
                35:'15x118y-2397z',
                36:'163x264y-2379z',
                37:'1649x1435y-989z',
                38:'1673x1220y-1212z',
                39:'1676x1563y-711z',
                40:'1689x1689y-222z',
                41:'172x659y-2301z',
                42:'1730x1353y-967z',
                43:'1761x1477y-688z',
                44:'1777x1600y-198z',
                45:'1806x1266y-945z',
                46:'1841x1387y-665z',
                47:'1860x1506y-174z',
                48:'189x2162y-1024z',
                49:'190x1841y-1526z',
                50:'190x275y-2376z',
                51:'1917x1293y-642z',
                52:'1937x1407y-150z',
                53:'213x671y-2294z',
                54:'218x283y-2373z',
                55:'22x30y-2399z',
                56:'244x2327y-530z',
                57:'246x2012y-1284z',
                58:'248x289y-2369z',
                59:'256x680y-2287z',
                60:'26x140y-2395z',
                61:'279x293y-2365z',
                62:'27x588y-2326z',
                63:'289x1844y-1508z',
                64:'2x71y-2398z',
                65:'301x687y-2279z',
                66:'303x2159y-1002z',
                67:'312x294y-2361z',
                68:'33x2000y-1324z',
                69:'345x293y-2356z',
                70:'347x690y-2272z',
                71:'353x2009y-1264z',
                72:'366x2316y-506z',
                73:'378x288y-2352z',
                74:'388x1841y-1489z',
                75:'393x691y-2264z',
                76:'39x162y-2394z',
                77:'39x48y-2399z',
                78:'412x281y-2347z',
                79:'417x2150y-980z',
                80:'441x688y-2256z',
                81:'460x2000y-1243z',
                82:'487x1832y-1470z',
                83:'488x2299y-483z',
                84:'490x683y-2247z',
                85:'532x2134y-958z',
                86:'539x674y-2239z',
                87:'54x183y-2392z',
                88:'568x1985y-1223z',
                89:'587x1818y-1451z',
                90:'588x661y-2230z',
                91:'58x63y-2398z',
                92:'609x2275y-459z',
                93:'60x609y-2320z',
                94:'638x645y-2221z',
                95:'646x2113y-936z',
                96:'675x1964y-1202z',
                97:'687x1798y-1432z',
                98:'687x626y-2212z',
                99:'729x2244y-436z',
                100:'72x202y-2390z',
                101:'736x603y-2203z',
                102:'758x2085y-914z',
                103:'75x2158y-1046z',
                104:'781x1937y-1181z',
                105:'784x577y-2193z',
                106:'786x1773y-1413z',
                107:'78x77y-2397z',
                108:'7x11y-2399z',
                109:'7x95y-2398z',
                110:'832x547y-2183z',
                111:'847x2207y-412z',
                112:'870x2050y-892z',
                113:'884x1742y-1393z',
                114:'886x1904y-1160z',
                115:'92x220y-2388z',
                116:'95x628y-2314z',
                117:'963x2163y-389z',
                118:'97x1910y-1609z',
                119:'980x2010y-870z',
                120:'981x1705y-1374z',
                121:'990x1865y-1139z'}
       

shot2three25004xi = {
                1:'0x2426y-601z',
                2:'1003x2253y-405z',
                3:'100x1986y-1674z',
                4:'1021x2094y-906z',
                5:'1022x1776y-1431z',
                6:'1031x1943y-1187z',
                7:'104x92y-2496z',
                8:'1121x1732y-1410z',
                9:'1121x2201y-380z',
                10:'1133x2045y-883z',
                11:'1138x1896y-1165z',
                12:'118x246y-2484z',
                13:'1218x1683y-1390z',
                14:'1237x2143y-355z',
                15:'1242x1843y-1142z',
                16:'1244x1990y-859z',
                17:'127x2429y-576z',
                18:'129x102y-2494z',
                19:'1313x1627y-1369z',
                20:'1343x1785y-1120z',
                21:'1349x2078y-331z',
                22:'1351x1929y-836z',
                23:'138x671y-2404z',
                24:'1406x1566y-1348z',
                25:'143x262y-2482z',
                26:'1442x1721y-1098z',
                27:'1455x1863y-812z',
                28:'1458x2007y-306z',
                29:'145x2093y-1359z',
                30:'1495x1500y-1327z',
                31:'1538x1651y-1075z',
                32:'154x109y-2492z',
                33:'1556x1790y-788z',
                34:'1563x1930y-281z',
                35:'1582x1429y-1305z',
                36:'1630x1575y-1053z',
                37:'1653x1712y-765z',
                38:'1663x1848y-256z',
                39:'1664x1352y-1284z',
                40:'169x275y-2478z',
                41:'16x123y-2496z',
                42:'1718x1495y-1030z',
                43:'1743x1270y-1262z',
                44:'1746x1628y-741z',
                45:'1760x1760y-231z',
                46:'179x686y-2397z',
                47:'1802x1409y-1007z',
                48:'1834x1539y-717z',
                49:'1851x1667y-206z',
                50:'1881x1319y-984z',
                51:'1918x1445y-693z',
                52:'1937x1569y-181z',
                53:'197x2252y-1067z',
                54:'198x1918y-1590z',
                55:'198x286y-2475z',
                56:'1996x1346y-669z',
                57:'2018x1466y-156z',
                58:'222x699y-2389z',
                59:'227x295y-2472z',
                60:'23x32y-2499z',
                61:'254x2424y-552z',
                62:'256x2096y-1338z',
                63:'259x301y-2468z',
                64:'267x709y-2382z',
                65:'27x146y-2495z',
                66:'28x612y-2423z',
                67:'291x305y-2464z',
                68:'2x74y-2498z',
                69:'301x1921y-1571z',
                70:'313x715y-2374z',
                71:'316x2249y-1044z',
                72:'325x306y-2459z',
                73:'359x305y-2455z',
                74:'35x2084y-1380z',
                75:'361x719y-2366z',
                76:'367x2092y-1316z',
                77:'382x2413y-527z',
                78:'394x300y-2450z',
                79:'404x1918y-1551z',
                80:'410x720y-2358z',
                81:'41x169y-2493z',
                82:'41x50y-2499z',
                83:'429x293y-2445z',
                84:'435x2239y-1021z',
                85:'460x717y-2350z',
                86:'479x2083y-1295z',
                87:'508x1909y-1531z',
                88:'509x2395y-503z',
                89:'510x711y-2341z',
                90:'554x2223y-998z',
                91:'561x702y-2332z',
                92:'57x190y-2492z',
                93:'591x2067y-1274z',
                94:'60x66y-2498z',
                95:'612x1894y-1512z',
                96:'613x689y-2323z',
                97:'635x2370y-479z',
                98:'63x634y-2417z',
                99:'664x672y-2314z',
                100:'672x2201y-975z',
                101:'703x2046y-1252z',
                102:'715x1873y-1492z',
                103:'716x652y-2304z',
                104:'759x2338y-454z',
                105:'75x211y-2489z',
                106:'767x628y-2294z',
                107:'78x2248y-1089z',
                108:'790x2171y-952z',
                109:'814x2017y-1230z',
                110:'817x601y-2284z',
                111:'818x1847y-1472z',
                112:'82x80y-2497z',
                113:'866x570y-2274z',
                114:'882x2299y-429z',
                115:'8x12y-2499z',
                116:'8x99y-2498z',
                117:'906x2136y-929z',
                118:'921x1814y-1451z',
                119:'923x1983y-1209z',
                120:'95x229y-2487z',
                121:'99x654y-2410z'}


shot2three26004xi = {
                1:'0x2523y-625z',
                2:'103x680y-2507z',
                3:'1043x2343y-421z',
                4:'104x2063y-1738z',
                5:'1062x1847y-1488z',
                6:'1062x2177y-942z',
                7:'1073x2020y-1234z',
                8:'109x96y-2595z',
                9:'1166x1802y-1467z',
                10:'1166x2289y-395z',
                11:'1179x2127y-918z',
                12:'1183x1972y-1211z',
                13:'123x256y-2584z',
                14:'1267x1750y-1445z',
                15:'1286x2228y-370z',
                16:'1292x1917y-1188z',
                17:'1293x2070y-894z',
                18:'132x2526y-599z',
                19:'134x106y-2594z',
                20:'1366x1692y-1423z',
                21:'1397x1856y-1165z',
                22:'1403x2161y-344z',
                23:'1405x2007y-869z',
                24:'144x698y-2500z',
                25:'1462x1629y-1402z',
                26:'149x272y-2581z',
                27:'1500x1790y-1142z',
                28:'1513x1937y-845z',
                29:'1516x2087y-318z',
                30:'151x2176y-1413z',
                31:'1555x1560y-1380z',
                32:'1599x1717y-1118z',
                33:'160x114y-2592z',
                34:'1618x1862y-820z',
                35:'1625x2007y-292z',
                36:'1645x1486y-1358z',
                37:'1695x1638y-1095z',
                38:'1719x1780y-795z',
                39:'1730x1921y-266z',
                40:'1731x1406y-1335z',
                41:'176x286y-2578z',
                42:'1787x1555y-1071z',
                43:'17x128y-2596z',
                44:'1813x1321y-1313z',
                45:'1816x1693y-770z',
                46:'1830x1830y-240z',
                47:'1874x1465y-1047z',
                48:'187x714y-2492z',
                49:'1907x1600y-746z',
                50:'1925x1733y-215z',
                51:'1956x1371y-1023z',
                52:'1995x1503y-721z',
                53:'2015x1631y-189z',
                54:'204x2342y-1109z',
                55:'206x1995y-1654z',
                56:'206x297y-2574z',
                57:'2076x1400y-696z',
                58:'2099x1525y-163z',
                59:'231x727y-2485z',
                60:'237x307y-2570z',
                61:'24x33y-2599z',
                62:'265x2521y-574z',
                63:'266x2179y-1391z',
                64:'269x313y-2566z',
                65:'278x737y-2477z',
                66:'28x152y-2595z',
                67:'29x637y-2520z',
                68:'2x77y-2598z',
                69:'303x317y-2562z',
                70:'313x1997y-1633z',
                71:'326x744y-2469z',
                72:'328x2339y-1086z',
                73:'338x319y-2558z',
                74:'36x2167y-1435z',
                75:'373x317y-2553z',
                76:'375x748y-2461z',
                77:'382x2176y-1369z',
                78:'397x2510y-549z',
                79:'410x312y-2548z',
                80:'420x1994y-1613z',
                81:'426x749y-2452z',
                82:'42x176y-2593z',
                83:'43x52y-2599z',
                84:'447x305y-2542z',
                85:'452x2329y-1062z',
                86:'478x746y-2444z',
                87:'499x2166y-1347z',
                88:'528x1985y-1593z',
                89:'529x2491y-523z',
                90:'531x740y-2435z',
                91:'576x2312y-1038z',
                92:'584x730y-2425z',
                93:'59x198y-2591z',
                94:'615x2150y-1325z',
                95:'636x1970y-1572z',
                96:'637x716y-2416z',
                97:'63x68y-2598z',
                98:'65x660y-2513z',
                99:'660x2464y-498z',
                100:'691x699y-2406z',
                101:'699x2289y-1014z',
                102:'731x2127y-1302z',
                103:'744x1948y-1551z',
                104:'744x678y-2396z',
                105:'78x219y-2589z',
                106:'790x2431y-472z',
                107:'797x653y-2386z',
                108:'81x2338y-1133z',
                109:'822x2258y-990z',
                110:'846x2098y-1280z',
                111:'850x625y-2376z',
                112:'851x1921y-1530z',
                113:'85x83y-2597z',
                114:'8x103y-2597z',
                115:'8x12y-2599z',
                116:'901x592y-2365z',
                117:'917x2391y-447z',
                118:'943x2221y-966z',
                119:'957x1887y-1509z',
                120:'960x2062y-1257z',
                121:'99x239y-2587z'}

shot2three27004xi = {
                1:'0x2620y-649z',
                2:'103x248y-2686z',
                3:'107x706y-2603z',
                4:'1083x2433y-437z',
                5:'108x2139y-1802z',
                6:'1103x1918y-1545z',
                7:'1103x2261y-978z',
                8:'1114x2098y-1282z',
                9:'113x99y-2695z',
                10:'1211x1871y-1523z',
                11:'1211x2377y-410z',
                12:'1224x2209y-953z',
                13:'1229x2048y-1258z',
                14:'128x266y-2683z',
                15:'1316x1817y-1501z',
                16:'1336x2314y-384z',
                17:'1341x1991y-1234z',
                18:'1343x2150y-928z',
                19:'137x2623y-622z',
                20:'139x110y-2694z',
                21:'1418x1757y-1478z',
                22:'1451x1928y-1210z',
                23:'1457x2244y-357z',
                24:'1459x2084y-903z',
                25:'149x725y-2596z',
                26:'1518x1692y-1456z',
                27:'154x283y-2680z',
                28:'1558x1858y-1186z',
                29:'156x2260y-1467z',
                30:'1572x2012y-877z',
                31:'1575x2167y-330z',
                32:'1615x1620y-1433z',
                33:'1661x1783y-1161z',
                34:'167x118y-2692z',
                35:'1680x1933y-851z',
                36:'1688x2084y-303z',
                37:'1708x1543y-1410z',
                38:'1760x1701y-1137z',
                39:'1785x1849y-826z',
                40:'1797x1460y-1387z',
                41:'1797x1995y-277z',
                42:'17x133y-2696z',
                43:'183x297y-2677z',
                44:'1855x1614y-1112z',
                45:'1882x1372y-1363z',
                46:'1885x1758y-800z',
                47:'1900x1900y-250z',
                48:'1946x1522y-1088z',
                49:'194x741y-2588z',
                50:'1981x1662y-774z',
                51:'1999x1800y-223z',
                52:'2032x1424y-1063z',
                53:'2071x1561y-748z',
                54:'2092x1694y-196z',
                55:'212x2432y-1152z',
                56:'213x309y-2673z',
                57:'214x2072y-1717z',
                58:'2156x1454y-722z',
                59:'2180x1583y-169z',
                60:'240x755y-2581z',
                61:'246x318y-2669z',
                62:'25x34y-2699z',
                63:'275x2618y-596z',
                64:'276x2263y-1445z',
                65:'279x325y-2665z',
                66:'288x765y-2572z',
                67:'29x158y-2695z',
                68:'2x80y-2698z',
                69:'30x662y-2617z',
                70:'314x330y-2661z',
                71:'325x2074y-1696z',
                72:'338x773y-2564z',
                73:'341x2429y-1128z',
                74:'351x331y-2656z',
                75:'388x329y-2651z',
                76:'38x2250y-1490z',
                77:'390x777y-2556z',
                78:'397x2260y-1422z',
                79:'412x2606y-570z',
                80:'426x325y-2646z',
                81:'436x2071y-1675z',
                82:'443x777y-2547z',
                83:'44x182y-2693z',
                84:'44x54y-2699z',
                85:'464x317y-2640z',
                86:'470x2418y-1103z',
                87:'497x775y-2538z',
                88:'518x2250y-1399z',
                89:'548x2061y-1654z',
                90:'549x2586y-543z',
                91:'551x768y-2528z',
                92:'598x2401y-1078z',
                93:'606x758y-2519z',
                94:'61x206y-2691z',
                95:'639x2233y-1376z',
                96:'65x71y-2698z',
                97:'661x2045y-1633z',
                98:'662x744y-2509z',
                99:'685x2559y-517z',
                100:'68x685y-2610z',
                101:'718x726y-2499z',
                102:'726x2377y-1053z',
                103:'759x2209y-1352z',
                104:'773x2023y-1611z',
                105:'773x704y-2488z',
                106:'81x227y-2689z',
                107:'820x2525y-490z',
                108:'828x678y-2478z',
                109:'84x2428y-1176z',
                110:'853x2345y-1029z',
                111:'879x2179y-1329z',
                112:'882x649y-2467z',
                113:'884x1995y-1589z',
                114:'88x86y-2697z',
                115:'8x107y-2697z',
                116:'8x13y-2699z',
                117:'936x615y-2456z',
                118:'953x2483y-464z',
                119:'979x2307y-1004z',
                120:'994x1960y-1567z',
                121:'997x2142y-1305z'}

shot2three28004xi = {
                1:'0x2717y-673z',
                2:'1015x2392y-1041z',
                3:'1031x2032y-1625z',
                4:'1034x2221y-1354z',
                5:'107x257y-2786z',
                6:'111x732y-2700z',
                7:'1123x2524y-453z',
                8:'112x2215y-1867z',
                9:'1143x2345y-1015z',
                10:'1144x1989y-1603z',
                11:'1155x2176y-1329z',
                12:'117x103y-2795z',
                13:'1255x1940y-1580z',
                14:'1256x2465y-426z',
                15:'1269x2291y-989z',
                16:'1274x2124y-1304z',
                17:'132x276y-2783z',
                18:'1364x1885y-1556z',
                19:'1385x2400y-398z',
                20:'1391x2065y-1280z',
                21:'1393x2229y-962z',
                22:'142x2720y-645z',
                23:'144x114y-2793z',
                24:'1471x1823y-1533z',
                25:'1505x1999y-1255z',
                26:'1511x2327y-370z',
                27:'1513x2161y-936z',
                28:'155x752y-2692z',
                29:'1574x1754y-1509z',
                30:'160x293y-2779z',
                31:'1615x1927y-1230z',
                32:'162x2344y-1522z',
                33:'1630x2086y-910z',
                34:'1633x2248y-342z',
                35:'1675x1680y-1486z',
                36:'1722x1849y-1204z',
                37:'173x123y-2791z',
                38:'1743x2005y-883z',
                39:'1750x2162y-315z',
                40:'1771x1600y-1462z',
                41:'1825x1765y-1179z',
                42:'1851x1917y-856z',
                43:'1863x2069y-287z',
                44:'1864x1514y-1438z',
                45:'18x138y-2796z',
                46:'190x308y-2776z',
                47:'1924x1674y-1154z',
                48:'1952x1423y-1414z',
                49:'1955x1823y-830z',
                50:'1971x1971y-259z',
                51:'2018x1578y-1128z',
                52:'201x769y-2684z',
                53:'2054x1724y-803z',
                54:'2073x1867y-231z',
                55:'2107x1477y-1102z',
                56:'2148x1618y-776z',
                57:'2170x1757y-203z',
                58:'220x2522y-1195z',
                59:'221x320y-2772z',
                60:'222x2148y-1781z',
                61:'2236x1508y-749z',
                62:'2260x1642y-175z',
                63:'249x783y-2676z',
                64:'255x330y-2768z',
                65:'26x35y-2799z',
                66:'285x2715y-618z',
                67:'287x2347y-1498z',
                68:'290x337y-2764z',
                69:'299x794y-2668z',
                70:'2x83y-2798z',
                71:'30x164y-2794z',
                72:'326x342y-2759z',
                73:'32x686y-2714z',
                74:'337x2151y-1759z',
                75:'351x801y-2659z',
                76:'354x2519y-1169z',
                77:'364x343y-2754z',
                78:'39x2334y-1545z',
                79:'402x341y-2749z',
                80:'404x806y-2650z',
                81:'412x2344y-1474z',
                82:'428x2703y-591z',
                83:'441x337y-2744z',
                84:'453x2148y-1737z',
                85:'459x806y-2641z',
                86:'46x189y-2793z',
                87:'46x56y-2799z',
                88:'481x328y-2738z',
                89:'487x2508y-1144z',
                90:'515x803y-2632z',
                91:'537x2333y-1451z',
                92:'569x2138y-1715z',
                93:'570x2682y-563z',
                94:'572x797y-2622z',
                95:'620x2490y-1118z',
                96:'629x786y-2612z',
                97:'63x213y-2791z',
                98:'662x2316y-1427z',
                99:'685x2121y-1693z',
                100:'687x771y-2602z',
                101:'68x74y-2798z',
                102:'70x710y-2707z',
                103:'711x2654y-536z',
                104:'744x753y-2591z',
                105:'753x2465y-1092z',
                106:'787x2291y-1402z',
                107:'801x2098y-1671z',
                108:'802x730y-2581z',
                109:'84x236y-2788z',
                110:'850x2618y-509z',
                111:'859x704y-2570z',
                112:'87x2518y-1220z',
                113:'885x2432y-1067z',
                114:'911x2260y-1378z',
                115:'915x673y-2558z',
                116:'917x2068y-1648z',
                117:'91x90y-2797z',
                118:'970x638y-2547z',
                119:'988x2575y-481z',
                120:'9x110y-2797z',
                121:'9x13y-2799z'}

shot2three29004xi = {
                1:'0x2814y-697z',
                2:'1005x661y-2638z',
                3:'1023x2667y-498z',
                4:'1051x2478y-1078z',
                5:'1068x2105y-1683z',
                6:'1071x2301y-1402z',
                7:'111x266y-2885z',
                8:'115x759y-2796z',
                9:'1163x2614y-470z',
                10:'116x2292y-1931z',
                11:'1184x2429y-1051z',
                12:'1185x2061y-1660z',
                13:'1196x2254y-1377z',
                14:'121x107y-2895z',
                15:'1300x2010y-1636z',
                16:'1301x2553y-441z',
                17:'1315x2372y-1024z',
                18:'1320x2200y-1351z',
                19:'137x286y-2882z',
                20:'1413x1952y-1612z',
                21:'1435x2485y-412z',
                22:'1441x2139y-1325z',
                23:'1443x2309y-997z',
                24:'147x2817y-669z',
                25:'149x118y-2893z',
                26:'1523x1888y-1588z',
                27:'1559x2071y-1299z',
                28:'1565x2410y-383z',
                29:'1567x2238y-969z',
                30:'160x779y-2788z',
                31:'1631x1817y-1563z',
                32:'166x304y-2879z',
                33:'1673x1996y-1273z',
                34:'1688x2161y-942z',
                35:'168x2428y-1576z',
                36:'1691x2328y-355z',
                37:'1735x1740y-1539z',
                38:'1784x1915y-1247z',
                39:'179x127y-2891z',
                40:'1805x2076y-915z',
                41:'1813x2239y-326z',
                42:'1835x1657y-1514z',
                43:'1891x1828y-1221z',
                44:'1917x1985y-887z',
                45:'1930x2143y-297z',
                46:'1931x1568y-1489z',
                47:'196x319y-2875z',
                48:'1993x1734y-1195z',
                49:'19x143y-2896z',
                50:'2022x1474y-1464z',
                51:'2025x1888y-859z',
                52:'2041x2041y-268z',
                53:'208x796y-2780z',
                54:'2090x1635y-1168z',
                55:'2128x1785y-832z',
                56:'2147x1933y-239z',
                57:'2182x1530y-1142z',
                58:'2225x1676y-804z',
                59:'2247x1820y-210z',
                60:'228x2612y-1237z',
                61:'229x332y-2871z',
                62:'230x2225y-1845z',
                63:'2316x1562y-776z',
                64:'2341x1701y-182z',
                65:'258x811y-2772z',
                66:'264x342y-2867z',
                67:'27x37y-2899z',
                68:'295x2812y-640z',
                69:'297x2431y-1552z',
                70:'2x86y-2898z',
                71:'300x350y-2863z',
                72:'310x822y-2763z',
                73:'32x170y-2894z',
                74:'338x354y-2858z',
                75:'33x711y-2811z',
                76:'349x2228y-1822z',
                77:'364x830y-2754z',
                78:'366x2609y-1211z',
                79:'377x355y-2853z',
                80:'40x2417y-1600z',
                81:'416x354y-2847z',
                82:'419x834y-2745z',
                83:'426x2427y-1527z',
                84:'443x2799y-612z',
                85:'457x349y-2842z',
                86:'469x2224y-1799z',
                87:'476x835y-2735z',
                88:'47x196y-2892z',
                89:'48x58y-2899z',
                90:'498x340y-2836z',
                91:'505x2598y-1185z',
                92:'533x832y-2726z',
                93:'556x2416y-1502z',
                94:'589x2214y-1777z',
                95:'590x2778y-584z',
                96:'592x825y-2716z',
                97:'643x2579y-1158z',
                98:'651x814y-2705z',
                99:'66x221y-2890z',
                100:'686x2398y-1478z',
                101:'70x76y-2898z',
                102:'710x2197y-1754z',
                103:'711x799y-2695z',
                104:'736x2749y-555z',
                105:'73x736y-2804z',
                106:'771x780y-2684z',
                107:'780x2553y-1132z',
                108:'815x2373y-1453z',
                109:'830x2173y-1730z',
                110:'830x756y-2673z',
                111:'87x244y-2888z',
                112:'881x2712y-527z',
                113:'890x729y-2661z',
                114:'916x2519y-1105z',
                115:'91x2608y-1264z',
                116:'944x2340y-1427z',
                117:'948x697y-2650z',
                118:'949x2142y-1707z',
                119:'95x93y-2896z',
                120:'9x114y-2897z',
                121:'9x14y-2899z'}

shot2three30004xi = {
                1:'0x2912y-721z',
                2:'1040x684y-2729z',
                3:'1059x2759y-515z',
                4:'1088x2563y-1115z',
                5:'1105x2177y-1742z',
                6:'1108x2380y-1450z',
                7:'115x275y-2985z',
                8:'119x785y-2892z',
                9:'1204x2704y-486z',
                10:'120x2368y-1996z',
                11:'1225x2512y-1087z',
                12:'1226x2132y-1717z',
                13:'1238x2331y-1424z',
                14:'125x110y-2995z',
                15:'1345x2079y-1692z',
                16:'1346x2641y-456z',
                17:'1360x2454y-1059z',
                18:'1365x2275y-1398z',
                19:'142x296y-2981z',
                20:'1462x2019y-1668z',
                21:'1484x2571y-426z',
                22:'1490x2212y-1371z',
                23:'1492x2389y-1031z',
                24:'152x2915y-692z',
                25:'155x122y-2993z',
                26:'1576x1953y-1643z',
                27:'1612x2142y-1344z',
                28:'1619x2493y-397z',
                29:'1621x2315y-1003z',
                30:'166x806y-2884z',
                31:'1687x1880y-1617z',
                32:'171x314y-2978z',
                33:'1731x2065y-1317z',
                34:'1746x2235y-975z',
                35:'174x2511y-1631z',
                36:'1750x2408y-367z',
                37:'1794x1800y-1592z',
                38:'1845x1981y-1290z',
                39:'185x131y-2991z',
                40:'1867x2148y-946z',
                41:'1875x2316y-337z',
                42:'1898x1714y-1566z',
                43:'1956x1891y-1263z',
                44:'1983x2054y-918z',
                45:'1996x2217y-307z',
                46:'1997x1622y-1541z',
                47:'19x147y-2996z',
                48:'203x330y-2974z',
                49:'2061x1794y-1236z',
                50:'2092x1525y-1515z',
                51:'2095x1953y-889z',
                52:'2112x2112y-278z',
                53:'215x824y-2876z',
                54:'2162x1691y-1209z',
                55:'2201x1847y-860z',
                56:'2221x2000y-248z',
                57:'2258x1582y-1181z',
                58:'2301x1734y-831z',
                59:'2325x1882y-218z',
                60:'236x2702y-1280z',
                61:'237x343y-2970z',
                62:'238x2302y-1908z',
                63:'2396x1616y-803z',
                64:'2422x1759y-188z',
                65:'267x839y-2867z',
                66:'273x354y-2966z',
                67:'28x38y-2999z',
                68:'2x89y-2998z',
                69:'305x2909y-662z',
                70:'307x2515y-1605z',
                71:'310x362y-2961z',
                72:'321x850y-2858z',
                73:'33x176y-2994z',
                74:'349x366y-2956z',
                75:'34x735y-2908z',
                76:'361x2305y-1885z',
                77:'376x859y-2849z',
                78:'379x2699y-1253z',
                79:'390x368y-2951z',
                80:'42x2501y-1656z',
                81:'431x366y-2946z',
                82:'433x863y-2840z',
                83:'441x2511y-1580z',
                84:'458x2896y-633z',
                85:'473x361y-2940z',
                86:'485x2301y-1861z',
                87:'492x864y-2830z',
                88:'49x203y-2992z',
                89:'49x60y-2998z',
                90:'515x352y-2934z',
                91:'522x2687y-1226z',
                92:'552x861y-2820z',
                93:'575x2500y-1554z',
                94:'609x2290y-1838z',
                95:'610x2874y-604z',
                96:'612x853y-2809z',
                97:'665x2668y-1198z',
                98:'674x842y-2799z',
                99:'68x229y-2990z',
                100:'710x2481y-1529z',
                101:'734x2273y-1814z',
                102:'736x827y-2788z',
                103:'73x79y-2998z',
                104:'75x761y-2900z',
                105:'762x2844y-574z',
                106:'797x807y-2777z',
                107:'807x2641y-1171z',
                108:'843x2455y-1503z',
                109:'859x2248y-1790z',
                110:'859x782y-2765z',
                111:'90x253y-2987z',
                112:'911x2805y-545z',
                113:'920x754y-2753z',
                114:'948x2606y-1143z',
                115:'94x2698y-1307z',
                116:'976x2421y-1477z',
                117:'981x721y-2741z',
                118:'982x2216y-1766z',
                119:'98x96y-2996z',
                120:'9x118y-2997z',
                121:'9x14y-2999z'}         


shot2three31004xi = {
                1:'0x3009y-745z',
                2:'1009x2502y-1526z',
                3:'1013x745y-2833z',
                4:'1015x2290y-1825z',
                5:'101x99y-3096z',
                6:'1075x706y-2820z',
                7:'1094x2850y-533z',
                8:'10x122y-3097z',
                9:'10x15y-3099z',
                10:'1124x2648y-1152z',
                11:'1142x2250y-1800z',
                12:'1145x2459y-1499z',
                13:'118x284y-3084z',
                14:'123x811y-2989z',
                15:'1244x2794y-502z',
                16:'124x2445y-2060z',
                17:'1266x2596y-1123z',
                18:'1267x2203y-1774z',
                19:'1279x2409y-1472z',
                20:'130x114y-3095z',
                21:'1390x2148y-1749z',
                22:'1390x2729y-471z',
                23:'1406x2536y-1094z',
                24:'1411x2351y-1444z',
                25:'147x306y-3081z',
                26:'1511x2086y-1723z',
                27:'1534x2657y-441z',
                28:'1540x2286y-1417z',
                29:'1542x2468y-1065z',
                30:'157x3012y-715z',
                31:'160x126y-3093z',
                32:'1629x2018y-1697z',
                33:'1666x2213y-1389z',
                34:'1673x2576y-410z',
                35:'1675x2393y-1036z',
                36:'172x833y-2980z',
                37:'1743x1942y-1671z',
                38:'177x325y-3077z',
                39:'1788x2134y-1361z',
                40:'1804x2310y-1007z',
                41:'1808x2489y-379z',
                42:'180x2595y-1685z',
                43:'1854x1860y-1645z',
                44:'1907x2047y-1333z',
                45:'191x136y-3091z',
                46:'1929x2220y-978z',
                47:'1938x2393y-348z',
                48:'1961x1771y-1619z',
                49:'2021x1954y-1305z',
                50:'2050x2122y-948z',
                51:'2063x2291y-318z',
                52:'2064x1677y-1592z',
                53:'20x152y-3096z',
                54:'210x341y-3073z',
                55:'2130x1854y-1277z',
                56:'2161x1576y-1566z',
                57:'2165x2019y-919z',
                58:'2182x2182y-287z',
                59:'222x851y-2972z',
                60:'2234x1747y-1249z',
                61:'2274x1908y-889z',
                62:'2295x2067y-256z',
                63:'2333x1635y-1220z',
                64:'2378x1792y-859z',
                65:'2402x1945y-225z',
                66:'244x2792y-1323z',
                67:'245x355y-3069z',
                68:'246x2378y-1972z',
                69:'2476x1670y-829z',
                70:'2503x1818y-194z',
                71:'276x867y-2963z',
                72:'282x366y-3065z',
                73:'29x39y-3099z',
                74:'2x92y-3098z',
                75:'316x3006y-684z',
                76:'317x2599y-1659z',
                77:'321x374y-3060z',
                78:'331x879y-2954z',
                79:'34x182y-3094z',
                80:'35x760y-3005z',
                81:'361x378y-3055z',
                82:'373x2382y-1948z',
                83:'389x887y-2944z',
                84:'391x2789y-1295z',
                85:'403x380y-3050z',
                86:'43x2584y-1711z',
                87:'445x378y-3044z',
                88:'448x892y-2934z',
                89:'456x2595y-1633z',
                90:'474x2992y-654z',
                91:'489x373y-3038z',
                92:'501x2378y-1924z',
                93:'508x893y-2924z',
                94:'51x210y-3092z',
                95:'51x62y-3098z',
                96:'533x364y-3032z',
                97:'539x2777y-1266z',
                98:'570x889y-2914z',
                99:'595x2583y-1606z',
                100:'630x2367y-1899z',
                101:'631x2970y-624z',
                102:'633x882y-2903z',
                103:'687x2757y-1238z',
                104:'696x870y-2892z',
                105:'70x236y-3090z',
                106:'733x2564y-1580z',
                107:'759x2349y-1875z',
                108:'75x82y-3097z',
                109:'760x854y-2881z',
                110:'787x2938y-593z',
                111:'78x787y-2997z',
                112:'824x834y-2869z',
                113:'834x2729y-1210z',
                114:'872x2537y-1553z',
                115:'887x2323y-1850z',
                116:'888x809y-2857z',
                117:'93x261y-3087z',
                118:'941x2899y-563z',
                119:'951x779y-2845z',
                120:'97x2788y-1351z',
                121:'980x2693y-1181z'}

shot2three32004xi = {
                1:'0x3203y-793z',
                2:'1002x3086y-599z',
                3:'1012x829y-3029z',
                4:'103x2968y-1438z',
                5:'1043x2866y-1257z',
                6:'1074x2663y-1624z',
                7:'1079x793y-3015z',
                8:'1080x2438y-1943z',
                9:'108x106y-3296z',
                10:'10x130y-3297z',
                11:'10x16y-3299z',
                12:'1144x752y-3002z',
                13:'1165x3034y-567z',
                14:'1196x2819y-1227z',
                15:'1215x2395y-1916z',
                16:'1219x2618y-1596z',
                17:'126x303y-3283z',
                18:'131x2598y-2189z',
                19:'131x863y-3182z',
                20:'1324x2974y-534z',
                21:'1348x2764y-1196z',
                22:'1349x2345y-1889z',
                23:'1362x2564y-1567z',
                24:'138x122y-3294z',
                25:'1480x2287y-1862z',
                26:'1480x2906y-502z',
                27:'1496x2700y-1165z',
                28:'1502x2503y-1537z',
                29:'156x325y-3280z',
                30:'1608x2221y-1834z',
                31:'1633x2828y-469z',
                32:'1639x2434y-1508z',
                33:'1642x2627y-1134z',
                34:'168x3206y-761z',
                35:'170x135y-3292z',
                36:'1734x2148y-1807z',
                37:'1774x2356y-1479z',
                38:'1781x2743y-436z',
                39:'1783x2547y-1103z',
                40:'183x886y-3173z',
                41:'1856x2068y-1779z',
                42:'189x346y-3276z',
                43:'1904x2271y-1449z',
                44:'191x2763y-1794z',
                45:'1921x2459y-1072z',
                46:'1925x2649y-404z',
                47:'1974x1980y-1751z',
                48:'2030x2179y-1419z',
                49:'204x145y-3290z',
                50:'2054x2363y-1041z',
                51:'2063x2548y-371z',
                52:'2088x1886y-1723z',
                53:'2151x2080y-1390z',
                54:'2182x2259y-1009z',
                55:'2196x2439y-338z',
                56:'2197x1785y-1695z',
                57:'21x162y-3295z',
                58:'224x363y-3272z',
                59:'2268x1973y-1360z',
                60:'2301x1677y-1667z',
                61:'2304x2149y-978z',
                62:'2323x2323y-305z',
                63:'2378x1860y-1329z',
                64:'237x906y-3164z',
                65:'2421x2032y-946z',
                66:'2443x2200y-272z',
                67:'2483x1741y-1299z',
                68:'2532x1908y-915z',
                69:'2557x2071y-240z',
                70:'260x2972y-1408z',
                71:'261x378y-3267z',
                72:'262x2532y-2099z',
                73:'2635x1777y-883z',
                74:'2664x1935y-207z',
                75:'294x923y-3154z',
                76:'2x98y-3298z',
                77:'300x389y-3263z',
                78:'31x42y-3299z',
                79:'336x3200y-729z',
                80:'338x2766y-1766z',
                81:'342x398y-3257z',
                82:'353x935y-3144z',
                83:'36x193y-3294z',
                84:'37x809y-3199z',
                85:'384x403y-3252z',
                86:'397x2535y-2073z',
                87:'414x944y-3134z',
                88:'417x2969y-1378z',
                89:'429x404y-3246z',
                90:'46x2751y-1821z',
                91:'474x402y-3240z',
                92:'477x949y-3124z',
                93:'485x2762y-1738z',
                94:'504x3185y-696z',
                95:'520x397y-3234z',
                96:'533x2531y-2048z',
                97:'541x950y-3113z',
                98:'54x223y-3291z',
                99:'54x66y-3298z',
                100:'567x387y-3227z',
                101:'574x2956y-1348z',
                102:'607x947y-3102z',
                103:'633x2750y-1710z',
                104:'670x2520y-2022z',
                105:'672x3161y-664z',
                106:'674x939y-3090z',
                107:'731x2935y-1318z',
                108:'741x926y-3079z',
                109:'75x251y-3289z',
                110:'781x2729y-1681z',
                111:'808x2500y-1995z',
                112:'809x909y-3067z',
                113:'80x87y-3297z',
                114:'838x3128y-632z',
                115:'83x837y-3190z',
                116:'877x887y-3054z',
                117:'888x2905y-1288z',
                118:'928x2700y-1653z',
                119:'944x2473y-1969z',
                120:'945x861y-3042z',
                121:'99x278y-3286z'}

shot2three33004xi = {
                1:'0x3203y-793z',
                2:'1002x3086y-599z',
                3:'1012x829y-3029z',
                4:'103x2968y-1438z',
                5:'1043x2866y-1257z',
                6:'1074x2663y-1624z',
                7:'1079x793y-3015z',
                8:'1080x2438y-1943z',
                9:'108x106y-3296z',
                10:'10x130y-3297z',
                11:'10x16y-3299z',
                12:'1144x752y-3002z',
                13:'1165x3034y-567z',
                14:'1196x2819y-1227z',
                15:'1215x2395y-1916z',
                16:'1219x2618y-1596z',
                17:'126x303y-3283z',
                18:'131x2598y-2189z',
                19:'131x863y-3182z',
                20:'1324x2974y-534z',
                21:'1348x2764y-1196z',
                22:'1349x2345y-1889z',
                23:'1362x2564y-1567z',
                24:'138x122y-3294z',
                25:'1480x2287y-1862z',
                26:'1480x2906y-502z',
                27:'1496x2700y-1165z',
                28:'1502x2503y-1537z',
                29:'156x325y-3280z',
                30:'1608x2221y-1834z',
                31:'1633x2828y-469z',
                32:'1639x2434y-1508z',
                33:'1642x2627y-1134z',
                34:'168x3206y-761z',
                35:'170x135y-3292z',
                36:'1734x2148y-1807z',
                37:'1774x2356y-1479z',
                38:'1781x2743y-436z',
                39:'1783x2547y-1103z',
                40:'183x886y-3173z',
                41:'1856x2068y-1779z',
                42:'189x346y-3276z',
                43:'1904x2271y-1449z',
                44:'191x2763y-1794z',
                45:'1921x2459y-1072z',
                46:'1925x2649y-404z',
                47:'1974x1980y-1751z',
                48:'2030x2179y-1419z',
                49:'204x145y-3290z',
                50:'2054x2363y-1041z',
                51:'2063x2548y-371z',
                52:'2088x1886y-1723z',
                53:'2151x2080y-1390z',
                54:'2182x2259y-1009z',
                55:'2196x2439y-338z',
                56:'2197x1785y-1695z',
                57:'21x162y-3295z',
                58:'224x363y-3272z',
                59:'2268x1973y-1360z',
                60:'2301x1677y-1667z',
                61:'2304x2149y-978z',
                62:'2323x2323y-305z',
                63:'2378x1860y-1329z',
                64:'237x906y-3164z',
                65:'2421x2032y-946z',
                66:'2443x2200y-272z',
                67:'2483x1741y-1299z',
                68:'2532x1908y-915z',
                69:'2557x2071y-240z',
                70:'260x2972y-1408z',
                71:'261x378y-3267z',
                72:'262x2532y-2099z',
                73:'2635x1777y-883z',
                74:'2664x1935y-207z',
                75:'294x923y-3154z',
                76:'2x98y-3298z',
                77:'300x389y-3263z',
                78:'31x42y-3299z',
                79:'336x3200y-729z',
                80:'338x2766y-1766z',
                81:'342x398y-3257z',
                82:'353x935y-3144z',
                83:'36x193y-3294z',
                84:'37x809y-3199z',
                85:'384x403y-3252z',
                86:'397x2535y-2073z',
                87:'414x944y-3134z',
                88:'417x2969y-1378z',
                89:'429x404y-3246z',
                90:'46x2751y-1821z',
                91:'474x402y-3240z',
                92:'477x949y-3124z',
                93:'485x2762y-1738z',
                94:'504x3185y-696z',
                95:'520x397y-3234z',
                96:'533x2531y-2048z',
                97:'541x950y-3113z',
                98:'54x223y-3291z',
                99:'54x66y-3298z',
                100:'567x387y-3227z',
                101:'574x2956y-1348z',
                102:'607x947y-3102z',
                103:'633x2750y-1710z',
                104:'670x2520y-2022z',
                105:'672x3161y-664z',
                106:'674x939y-3090z',
                107:'731x2935y-1318z',
                108:'741x926y-3079z',
                109:'75x251y-3289z',
                110:'781x2729y-1681z',
                111:'808x2500y-1995z',
                112:'809x909y-3067z',
                113:'80x87y-3297z',
                114:'838x3128y-632z',
                115:'83x837y-3190z',
                116:'877x887y-3054z',
                117:'888x2905y-1288z',
                118:'928x2700y-1653z',
                119:'944x2473y-1969z',
                120:'945x861y-3042z',
                121:'99x278y-3286z'}
      
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "shoot2three4xi" usage = "creating spheres">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def shoot2three4xi(queue2three = None, consumer_channel2three = None, publisher_channel2three = None,
             start2distance = None, interval2distance = None, max2layer = None, marginal2layer = None, max2count = None,
             marginal2count = None, sign2x = None, sign2y = None, sign2z = None, max2iterate = None,
             start2plusa = None, max2plusa = None, min2plusa = None, start2minusa = None, max2minusa = None, min2minusa = None,
             start2pluse = None, max2pluse = None, min2pluse = None, start2minuse = None, max2minuse = None, min2minuse = None,
             increase2distance = None, change2a = None, change2e = None, increase2a = None, increase2e = None ):
    '''
    shoots according to required parameters
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    print("\n (STEP 1A0/33) OF SHOOT2THREE4XI - STARTED TIME: ", time2start)
    
    
    print("\n (STEP 1A2/33) OF SHOOT2THREE4XI -  QUEUE2THREE: ", queue2three)      
    # 
    
    print("\n (STEP 1A3/33) OF SHOOT2THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
    # 
          
    print("\n (STEP 1A4/33) OF SHOOT2THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
    # 
                
     
    print("\n (STEP 1A5/33) OF SHOOT2THREE4XI -  START TO DISTANCE: ", start2distance) 
    print("\n (STEP 1A6/33) OF SHOOT2THREE4XI -  INTERVAL TO DISTANCE: ", interval2distance)
    print("\n (STEP 1A7/33) OF SHOOT2THREE4XI -  MAX TO LAYER: ", max2layer)    
    print("\n (STEP 1A8/33) OF SHOOT2THREE4XI -  MARGINAL TO LAYER: ", marginal2layer)
    print("\n (STEP 1A9/33) OF SHOOT2THREE4XI -  SIGN TO X: ", sign2x)       
    print("\n (STEP 1A10/33) OF SHOOT2THREE4XI -  SIGN TO Y: ", sign2y)
    print("\n (STEP 1A11/33) OF SHOOT2THREE4XI -  SIGN TO Z: ", sign2z)    
    print("\n (STEP 1A12/33) OF SHOOT2THREE4XI -  START TO PLUS AZIMUTH: ", start2plusa)
    print("\n (STEP 1A13/33) OF SHOOT2THREE4XI -  MAX TO PLUS AZIMUTH: ", max2plusa)       
    print("\n (STEP 1A14/33) OF SHOOT2THREE4XI -  MIN TO PLUS AZIMUTH: ", min2plusa)
    print("\n (STEP 1A15/33) OF SHOOT2THREE4XI -  START TO MINUS AZIMUTH: ", start2minusa)
    print("\n (STEP 1A16/33) OF SHOOT2THREE4XI -  MAX TO MINUS AZIMUTH: ", max2minusa)
    print("\n (STEP 1A17/33) OF SHOOT2THREE4XI -  MIN TO MINUS AZIMUTH: ", min2minusa)    
    print("\n (STEP 1A18/33) OF SHOOT2THREE4XI -  START TO PLUS ELEVATION: ", start2pluse)
    print("\n (STEP 1A19/33) OF SHOOT2THREE4XI -  MAX TO PLUS ELEVATION: ", max2pluse)
    print("\n (STEP 1A20/33) OF SHOOT2THREE4XI -  MIN TO PLUS ELEVATION: ", min2pluse)
    print("\n (STEP 1A21/33) OF SHOOT2THREE4XI -  START TO MINUS ELEVATION: ", start2minuse) 
    print("\n (STEP 1A22/33) OF SHOOT2THREE4XI -  MAX TO MINUS ELEVATION: ", max2minuse)
    print("\n (STEP 1A23/33) OF SHOOT2THREE4XI -  MIN TO MINUS ELEVATION: ", min2minuse)
    print("\n (STEP 1A24/33) OF SHOOT2THREE4XI -  INCREASE TO DISTANCE: ", increase2distance)
    print("\n (STEP 1A25/33) OF SHOOT2THREE4XI -  CHANGE TO AZIMUTH: ", change2a) 
    print("\n (STEP 1A26/33) OF SHOOT2THREE4XI -  CHANGE TO ELEVATION: ", change2e)           
    print("\n (STEP 1A27/33) OF SHOOT2THREE4XI -  INCREASE TO AZIMUTH: ", increase2a)  
    print("\n (STEP 1A28/33) OF SHOOT2THREE4XI -  INCREASE TO ELEVATION: ", increase2e)  
                                                      
    # =================================================================================================                   
    # INITIALIZATIONS
    # =================================================================================================         
    print("\n (STEP 2A/33) OF SHOOT2THREE4XI - INITIALIZING SPHERE4XI ") 
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SPHERE2XI USING FUNCTION
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    init_sphere2three4xi(message2sphere = "shoot4core", message2shot = 'shoot4skeleton')
    print("\n (STEP 2C/33) OF SHOOT2THREE4XI - PEFORMED INIT_SPHERE2THREE4XI")     

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                        
    if start2distance is None:
        start2distance = 100
    start2distance4xi = int(start2distance)
    print("\n (STEP 3A/33) OF SHOOT2THREE4XI - START2DISTANCE4XI: ", start2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # INTERVAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                     
    if interval2distance is None:
        interval2distance = 100
    interval2distance4xi = int(interval2distance)  
    print("\n (STEP 4A/33) OF SHOOT2THREE4XI - INTERVAL TO DISTANCE: ", interval2distance4xi)
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX PER LAYER WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2layer is None:
        max2layer = 100
    max2layer4xi = int(max2layer)
    
    if marginal2layer is None:                              
        marginal2layer = 1.2
    marginal2layer4xi = marginal2layer
        
    omax2layer4xi = max2layer4xi
    
    max2layer4xi = int(marginal2layer4xi * max2layer4xi)
    print("\n (STEP 5A/33) OF SHOOT2THREE4XI - MAXIMUM SHOTS PER LAYER: ", max2layer4xi, " WITH MARGINAL TO LAYER: ", marginal2layer4xi) 
    # 
                                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # MAX SHOTS WITH MARGINAL
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if max2count is None:
        max2count = 100
    max2count4xi = int(max2count) 
         
    if marginal2count is None:    
        marginal2count = 1.2
    marginal2count4xi = marginal2count     
        
    omax2count4xi = max2count4xi
    
    max2count4xi = int(marginal2count4xi * max2count4xi)
            
    print("\n (STEP 6A/33) OF SHOOT2THREE4XI - MAXIMUM SHOTS: ", max2count4xi, " MARGINAL TO COUNT: ", marginal2count4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # TIME
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    time2start4xi = time4xi()                        
    print("\n (STEP 7A/33) OF SHOOT2THREE4XI - START TIME: ", time2start4xi)
    # 
                                                                               
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # REQUIRED SIGNS FOR (X,Y,Z)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if sign2x is None:
        sign2x = '+' 
    sign2x4xi = sign2x
           
    if sign2y is None:
        sign2y = '+'
    sign2y4xi = sign2y    
    if sign2z is None:    
        sign2z = '+'
    sign2z4xi = sign2z
        
    print("\n (STEP 8A/33) OF SHOOT2THREE4XI - X-SIGN: ", sign2x4xi, 'Y-SIGN: ', sign2y4xi, 'Z-SIGN: ', sign2z4xi)
    #     
         
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ITERATIONS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
    if max2iterate is None:
        max2iterate = max2count * 21                                # success ratio may be less than 9% 
    max2iterate4xi = max2iterate
    print("\n (STEP 9A/33) OF SHOOT2THREE4XI - MAXIMUM TO ITERATIONS: ", max2iterate4xi) 
    # 
      
    # =================================================================================================                   
    # AZIMUTH
    # =================================================================================================                
                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # azimuth and elevation angle initialized
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ref: http://en.wikipedia.org/wiki/Radian#Conversion_between_radians_and_degrees
    # one radian is equal to 180/p degrees <=> 1 deg = rad * 180 / pi                             
    # pi/6 = 30, pi/4 = 45, pi/3 = 60, pi/2 = 90, 2/3*pi = 120, 3/4pi=135, 5/6*pi = 150, pi = 180
    # 7/6*pi = 210, 5/4*pi = 225...3*pi/2 = 270, 5*pi/3 = 300 ... 2*pi = 0 or 360 degrees
    # I   = 0...90    (0...pi/2) :     sin+, cos+
    # II  = 90...180  (pi/2...pi):     sin+, cos- 
    # III = 180...270 (pi...3*pi/2):   sin-, cos-
    # IV  = 270...360 (3*pi/2...2*pi): sin-, cos+
    # ref: http://en.wikipedia.org/wiki/Azimuth
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2plusa is None:
        start2plusa = pi/6                      # start plus azimuth 30 degrees - iterates smaller
    start2plusa4xi = start2plusa                                                               
    print("\n (STEP 10A/33) OF SHOOT2THREE4XI - START TO PLUS AZIMUTH: ", start2plusa4xi) 
    # 
                                     
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2plusa is None:
        max2plusa = 2*pi                        # extreme plus azimuth 360 degrees around sideways
    max2plusa4xi = max2plusa    
    print("\n (STEP 10B/33) OF SHOOT2THREE4XI - MAX TO PLUS AZIMUTH: ", max2plusa4xi) 
    # 
                                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2plusa is None:
        min2plusa = pi/240                      # minum positive azimuth 0.75 degrees sideways 
    min2plusa4xi = min2plusa    
    print("\n (STEP 10C/33) OF SHOOT2THREE4XI - MIN TO PLUS AZIMUTH: ", min2plusa4xi) 
    #                                  
                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minusa is None:
        start2minusa = -pi/6                    # start minus azimuth -30 degrees sideways 
    start2minusa4xi = start2minusa
                                                                  
    print("\n (STEP 10D/33) OF SHOOT2THREE4XI - START TO MINUS AZIMUTH: ", start2minusa4xi) 
    # 
                  
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2minusa is None:
        max2minusa = -0.98*2*pi                 # extreme minus azimuth almost -360 degrees 
    max2minusa4xi = max2minusa    
    print("\n (STEP 10E/33) OF SHOOT2THREE4XI - MAX TO MINUS AZIMUTH: ", max2minusa4xi) 
    # 
                                                            
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minusa is None:
        min2minusa = -pi/240                    # nearest to zero minus to azimuth
    min2minusa4xi = min2minusa    
    print("\n (STEP 10F/33) MIN TO MINUS AZIMUTH: ", min2minusa4xi) 
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2a is None:
        increase2a = 0.01                       # increase to azimuth
    increase2a4xi = increase2a    
    print("\n (STEP 10G/33) INCREASE2A4XI: ", increase2a4xi)     
    # 
                                                          
    # =================================================================================================                   
    # ELEVATION
    # =================================================================================================                
                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2pluse is None:
        start2pluse = pi/6                      # start plus elevation 30 degrees up 
    start2pluse4xi = start2pluse    
    print("\n (STEP 11A/33) OF SHOOT2THREE4XI - START TO PLUS ELEVATION: ", start2pluse4xi) 
    # 
                                          
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                       
    if max2pluse is None:
        max2pluse = pi                          # most flexible elevation 180 degrees 
    max2pluse4xi = max2pluse    
    print("\n (STEP 11B/33) OF SHOOT2THREE4XI - MAX TO PLUS ELEVATION: ", max2pluse4xi) 
    # 
                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2pluse is None:
        min2pluse = pi/240                      # lowest plus to elevation 0.75 degrees                          
    min2pluse4xi = min2pluse    
    print("\n (STEP 11C/33) OF SHOOT2THREE4XI - MIN TO PLUS ELEVATION: ", min2pluse4xi) 
    # 
                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
    if start2minuse is None:
        start2minuse = -pi/6                    # start minus elevation -30 degrees down                                                
    start2minuse4xi = start2minuse    
    print("\n (STEP 11D/33) OF SHOOT2THREE4XI - START TO MINUS ELEVATION: ", start2minuse4xi) 
    # 
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                      
    if max2minuse is None:
        max2minuse = -0.98*pi                   # most painful minus elevation almost -180 degrees
    max2minuse4xi = max2minuse    
    print("\n (STEP 11E/33) OF SHOOT2THREE4XI - MAX TO MINUS ELEVATION: ", max2minuse4xi) 
    # 
                                                
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if min2minuse is None:
        min2minuse = -pi/240                    # least painful minus elevation -0.75 degrees
    min2minuse4xi = min2minuse                                  
    print("\n (STEP 11F/33) OF SHOOT2THREE4XI - MIN TO MINUS ELEVATION: ", min2minuse4xi) 
    # 


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
    if increase2e is None:
        increase2e = 0.01                       # increase to elevation
    increase2e4xi = increase2e    
    print("\n (STEP 11G/33) INCREASE2E4XI: ", increase2e4xi)     
    #     
                                               
    # =================================================================================================      
    # ALGORITHM TUNING 
    # =================================================================================================      
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE INCREMENTS 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        
    if increase2distance is None:
        increase2distance = 1                   # used to control number of shots per layer
    increase2distance4xi = int(increase2distance)    
    print("\n (STEP 12A/33) OF SHOOT2THREE4XI - INCREASE TO DISTANCE: ", increase2distance4xi) 
    # 
                                         
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if change2a is None: 
        change2a = pi / 60                      # 3 degrees change to azimuth
    change2a4xi = change2a    
    print("\n (STEP 12B/33) OF SHOOT2THREE4XI - CHANGE TO AZIMUTH: ", change2a4xi) 
    # 
                                        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION CHANGES 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if change2e is None:
        change2e = pi / 60                      # 3 degrees change to elevation
    change2e4xi = change2e    
    print("\n (STEP 12C/33) OF SHOOT2THREE4XI - CHANGE TO ELEVATION: ", change2e4xi) 
    # 
                                                                                                                                      
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2a4xi = '+'
    if sign2a4xi == '+':
        start2a4xi = start2plusa4xi
        min2a4xi = min2plusa4xi
        max2a4xi = max2plusa4xi
    else:
        start2a4xi = start2minusa4xi
        min2a4xi = min2minusa4xi
        max2a4xi = max2minusa4xi
        
    print("\n (STEP 14/33) OF SHOOT2THREE4XI - START AZIMUTH: ", start2a4xi, 'MIN AZIMUTH: ', min2a4xi, 'MAX AZIMUTH: ', max2a4xi) 
    # 
                                                                                                                   
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION SETTINGS BASED ON SIGN, WHICH MIGHT GET TUNED TO OPPOSITE SIGN LATER ON
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    sign2e4xi = '+'
    if sign2e4xi == '+':
       start2e4xi = start2pluse4xi
       min2e4xi = min2pluse4xi
       max2e4xi = max2pluse4xi
    else:
       start2e4xi = start2minuse4xi
       min2e4xi = min2minuse4xi
       max2e4xi = max2minuse4xi
            
    print("\n (STEP 15/33) OF SHOOT2THREE4XI - START ELEVATION: ", start2e4xi, 'MIN ELEVATION: ', min2e4xi, 'MAX ELEVATION: ', max2e4xi) 
    # 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # AZIMUTH START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    a2shot4xi = start2a4xi 
                                                                                                                    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ELEVATION START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                              
    e2shot4xi = start2e4xi                            
                                                                                                              
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # DISTANCE START SETTING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                          
    d2shot4xi = start2distance4xi

    print("\n (STEP 16/33) OF SHOOT2THREE4XI - START AZIMUTH: ", a2shot4xi, ' START ELEVATION: ', e2shot4xi, ' START DISTANCE: ', d2shot4xi) 
    # 
           
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # initializations for while loop 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    count2shot = 0                                   # shots
    
    count2layer = 1                                  # layers                                                           
    
    count2ok = 0                                     # ok shots with all of (x,y,z) ok 
    
    count2distance = 0                               # measures shot per layer                       
    
    count2iterate = 0                                # hunting for right (x,y,z) combination
    
    count2rejected = 0                               # rejected
    
    ack2x = False                                    # validation for x-coordinate
    nack2x = True
    
    ack2y = False                                    # validation for y-coordinate
    nack2y = True                    
    
    ack2z = False                                    # validation for z-coordinate
    nack2z = True
    
    print("\n (STEP 17A/33) OF SHOOT2THREE4XI - START TIME OF SHOOTING: ", time4xi(), " FOR ", max2count4xi, " SHOTS")
    # 
    print("\n (STEP 17B/33) OF SHOOT2THREE4XI - COUNT2OK: ", count2ok, " MAX2COUNT4XI: ", max2count4xi, " COUNT2ITERATE: ", count2iterate, " MAX2ITERATE4XI: ", max2iterate4xi)
    # 
       
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                             
    while ((count2ok <= max2count4xi) and (count2iterate < max2iterate4xi)):   
        # ok shots staying less or equal to that of required amount & iterations not exceeding maximum  
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        count2iterate = count2iterate + 1    
        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if a2shot4xi >= 0:        
            a2shot4xi = a2shot4xi + change2a4xi
            if a2shot4xi >= max2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi 
                print("\n (STEP 18A/33) OF SHOOT2THREE4XI - AZIMUTH BECAME BIGGER THAN MAXIMUM: ", max2a4xi , " NEW AZIMUTH: ", a2shot4xi)    
        else:
            a2shot4xi = a2shot4xi - change2a4xi
            if a2shot4xi <= min2a4xi:
                start2a4xi = start2a4xi * 1.01
                a2shot4xi = start2a4xi  
                print("\n (STEP 18B/33) OF SHOOT2THREE4XI - AZIMUTH BECAME SMALLER THAN MINIMUM: ", min2a4xi , " NEW AZIMUTH: ", a2shot4xi)  
        
        print("\n (STEP 18C/33) OF SHOOT2THREE4XI - AZIMUTH CHANGES CHECKED ")  
                
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
        if (a2shot4xi >= 2*pi):
            sign2a4xi = '-'                                          # switch to negative
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2minusa4xi               # new minus azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2minusa4xi                                 # new minimum to azimuth
            max2a4xi = max2minusa4xi                                 # new maximum to azimuth
            print("\n (STEP 19/33) OF SHOOT2THREE4XI - AZIMUTH BECAME BIGGER THAN 2*PI , NEW AZIMUTH: ", a2shot4xi) 
             
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # AZIMUTH ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                             
        if (a2shot4xi <= -2*pi):
            sign2a4xi = '+'                                          # switch to positive
            change2a4xi = 0.98 * change2a4xi                         # change2a always positive
            start2a4xi = change2a4xi * start2plusa4xi                # new positive azimuth start
            a2shot4xi = start2a4xi                                   # new azimuth
            min2a4xi = min2plusa4xi                                  # new minimum to azimuth
            max2a4xi = max2plusa4xi                                  # new maximum to azimuth
            print("\n (STEP 20A/33) OF SHOOT2THREE4XI - AZIMUTH BECAME LESS THAN -2*PI, NEW AZIMUTH: ", a2shot4xi) 
        
        print("\n (STEP 20B/33) OF SHOOT2THREE4XI - AZIMUTH MAX AND MINIMUM CHANGES CHECKED ")       
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION CHANGES
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if e2shot4xi <= 0:
            e2shot4xi = e2shot4xi - increase2e4xi
            if e2shot4xi <= min2e4xi:
                change2e4xi = 1.02 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 21/33) OF SHOOT2THREE4XI - ELEVATION BECAME LESS THAN MINIMUM: ", min2e4xi, " NEW ELEVATION: ", e2shot4xi)                                   
        else:
            e2shot4xi = e2shot4xi + increase2e4xi
            if e2shot4xi >= max2e4xi:
                change2e4xi = 1.08 * change2e4xi
                start2e4xi = change2e4xi * start2e4xi
                e2shot4xi = start2e4xi
                print("\n (STEP 22A/33) OF SHOOT2THREE4XI - ELEVATION BECAME BIGGER THAN MAXIMUM: ", max2e4xi, " NEW ELEVATION: ", e2shot4xi)  
        
        print("\n (STEP 22B/33) OF SHOOT2THREE4XI - ELEVATION CHANGES CHECKED ")                                                        
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MAXIMUM ALLOWED - RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                                                   
        if (e2shot4xi >= pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            sign2e4xi = '-'                                             # switch to negative
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2minuse4xi                  # new minus elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2minuse4xi                                    # new minimum to elevation
            max2e4xi = max2minuse4xi                                    # new maximum to elevation
            print("\n (STEP 23A/33) OF SHOOT2THREE4XI - ELEVATION BECAME BIGGER THAN PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 23B/33) OF SHOOT2THREE4XI - ELEVATION MAX CHANGE CHECKED ") 
                        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # ELEVATION ALGORITM CHECKING AGAINST MINIMUM ALLOWED- RESTART WITH TUNING, IF NECESSARY
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
        
        if (e2shot4xi <= -pi):
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # start again with a new elevation and new elevation change
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                            
            sign2e4xi = '+'                                             # switch to positive
            change2e4xi = 0.98 * change2e4xi                            # change2e always positive
            start2e4xi = change2e4xi * start2pluse4xi                   # new positive elevation start
            e2shot4xi = start2e4xi                                      # new azimuth
            min2e4xi = min2pluse4xi                                     # new minimum to elevation
            max2e4xi = max2pluse4xi                                     # new maximum to elevation        
            print("\n (STEP 24A/33) OF SHOOT2THREE4XI - ELEVATION BECAME LESS THAN -PI, NEW ELEVATION: ", e2shot4xi)
            
        print("\n (STEP 24B/33) OF SHOOT2THREE4XI - ELEVATION MIN CHANGE CHECKED ")         
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # SHOOT
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25A/33) OF SHOOT2THREE4XI - SETTING WITH SET_SPHERE2THREE4XI")  
        print("\n A2SHOT4XI OF SHOOT2THREE4XI: ", a2shot4xi)                       # 0.575958653158
        print("\n E2SHOT4XI OF SHOOT2THREE4XI: ", e2shot4xi)                       # 0.533598775598  
        print("\n D2SHOT4XI OF SHOOT2THREE4XI: ", d2shot4xi)                       # 100  
        print("\n INTERVAL2DISTANCE4XI OF SHOOT2THREE4XI: ", interval2distance4xi) # 100
                                                                                 
        shot2xi = set_sphere2three4xi(azimuth2shot = a2shot4xi, elevation2shot = e2shot4xi, distance2shot = d2shot4xi, area2shot = int(4*pi*d2shot4xi**2/interval2distance4xi))
        
        print("\n (STEP 25B/33) OF SHOOT2THREE4XI - PERFORMED SET_SPHERE2THREE4XI, SPHERE4XI: ", shot2xi)  
        # 
            
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CHECK THE SHOT 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        print("\n (STEP 25C/33) OF SHOOT2THREE4XI - GETTING")  
        shot2examine = get_sphere2three4xi(id2shot = 'Yes', x2shot = 'Yes', y2shot = 'Yes', z2shot = 'Yes', azimuth2shot = 'Yes', elevation2shot = 'Yes', distance2shot = 'Yes', area2shot = 'Yes')
        
        print("\n (STEP 25D/33) OF SHOOT2THREE4XI - PERFORMED GET")  
        # 
        
        print("\n (STEP 25E/33) OF SHOOT2THREE4XI - SHOT TO EXAMINE ", count2shot, ": ", shot2examine)  
        # 
         
        keys2examine = shot2examine.keys()
        print("\n (STEP 26A/33) OF SHOOT2THREE4XI - KEYS2EXAMINE: ", keys2examine)   
        # 
        
        for key2examine in sorted(keys2examine):
            print("\n (STEP 26B/33) OF SHOOT2THREE4XI - KEY2EXAMINE ", key2examine)  
            # 
            
            ack2x = False 
            nack2x = True                                  
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # X OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                        
            try:
                index2x=str.find(key2examine,'x')                               
                x2coordinate = int(key2examine[0:index2x])
                if x2coordinate >= 0:
                    if sign2x4xi == '+':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27A/33) OF SHOOT2THREE4XI - X2COORDINATE ACK: ", ack2x) 
                else:
                    if sign2x4xi == '-':
                        ack2x = True
                        nack2x = False
                        print("\n (STEP 27B/33) OF SHOOT2THREE4XI - X2COORDINATE ACK: ", ack2x)
                         
            except:
                print("\n (STEP 27C/33) : *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27D/33) OF SHOOT4XI -INDEX2X: ", index2x)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Y OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2y = False 
            nack2y = True     
            try:
                index2y=str.find(key2examine,'y')                               
                y2coordinate = int(key2examine[index2x+1:index2y])
                if y2coordinate >= 0:
                    if sign2y4xi == '+':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27E/33) OF SHOOT2THREE4XI - Y2COORDINATE ACK: ", ack2y)                                         
                else:
                    if sign2y4xi == '-':
                        ack2y = True
                        nack2y = False
                        print("\n (STEP 27F/33) OF SHOOT2THREE4XI - Y2COORDINATE ACK: ", ack2y)                               
            except:
                print("\n (STEP 27G/33) OF SHOOT2THREE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27H/33) OF SHOOT2THREE4XI - INDEX2Y: ", index2y)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # Z OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            ack2z = False 
            nack2z = True                                 
            try:
                index2z=str.find(key2examine,'z')                               
                z2coordinate = int(key2examine[index2y+1:index2z])
                if z2coordinate >= 0:
                    if sign2z4xi == '+':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27I/33) OF SHOOT2THREE4XI - Z2COORDINATE ACK: ", ack2z)                                               
                else:
                    if sign2z4xi == '-':
                        ack2z = True
                        nack2z = False
                        print("\n (STEP 27J/33) OF SHOOT2THREE4XI - Z2COORDINATE ACK: ", ack2z)                                  
            except:
                print("\n (STEP 27K/33) OF SHOOT2THREE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27L/33) OF SHOOT2THREE4XI - INDEX2Z: ", index2z)
                
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            # (X,Y,Z) OK ?
            # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                              
            try:                                                           
                if ((ack2x is True) and (ack2y is True) and (ack2z is True)):
                    print("\n (STEP 27M1/33) OF SHOOT2THREE4XI - OK: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")") 
                    # 
                    print("\n (STEP 27M2/33) OF SHOOT2THREE4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
                    # 
                    count2ok = count2ok + 1 
                    print("\n (STEP 27M3/33) OF SHOOT2THREE4XI - COUNT2OK: " , count2ok, " MAX2LAYER4Xi: ", max2layer4xi) 
                    
                    count2distance = count2distance + increase2distance4xi      # one more shot for this layer and distance
                    print("\n (STEP 27M4/33) OF SHOOT2THREE4XI - COUNT2DISTANCE: " , count2distance, " MAX2LAYER4Xi: ", max2layer4xi)
                    # 
                    
                    if count2distance >= max2layer4xi:
                        d2shot4xi = d2shot4xi + interval2distance4xi            # distance for the next layer
                        count2distance = 0
                        count2layer = count2layer + 1 
                        print("\n (STEP 27M5/33) OF SHOOT2THREE4XI - NEW LAYER NUMBER: ", count2layer, ' NEW DISTANCE: ', d2shot4xi)
                        # 
                    else:
                        pass 

                else:
                    print("\n (STEP 27P/33) OF SHOOT2THREE4XI - REJECTED: (" , x2coordinate, ",", y2coordinate, ",", z2coordinate, ")")
                    print("\n (STEP 27Q/33) OF SHOOT2THREE4XI - EXPECTED: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")")
                    
                    count2rejected = count2rejected + 1
                    # 
                    # 
                    
                    
                    
                                        
            except:
                print("\n (STEP 27S/33) OF SHOOT2THREE4XI - *** FAILED WITH KEY2EXAMINE: ", key2examine)
                print("\n (STEP 27T/33) OF SHOOT2THREE4XI - INDEX2Z: ", index2z)
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # CONTINUE WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                                    
        print("\n (STEP 28A/33) OF SHOOT2THREE4XI - CONTINUING WHILE WITH:")
        print("\n COUNT2OK OF SHOOT2THREE4XI: ", count2ok)
        print("\n COUNT2DISTANCE OF SHOOT2THREE4XI: ", count2distance)   
        print("\n MAX2COUNT OF SHOOT2THREE4XI: ", max2count4xi)                        
        print("\n COUNT2ITERATE OF SHOOT2THREE4XI: ", count2iterate)
        print("\n MAX2ITERATE OF SHOOT2THREE4XI: ", max2iterate4xi)                        

        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # END OF WHILE
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # EXAMINE RESULTS AFTER WHILE
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    time2end = time4xi()           
    print("\n (STEP 30A1/33) OF SHOOT2THREE4XI - STATISTICS FOR SHOOTING, WHICH ENDED: ", time2end)                           
    print("\n SHOTS OK OF SHOOT2THREE4XI: ", count2ok, " = ", int(100 * count2ok/max2count4xi), " %")                              
    print("\n SHOTS ORIGINALLY REQUIRED OF SHOOT2THREE4XI: ", omax2count4xi)      
    print("\n ITERATIONS NEEDED OF SHOOT2THREE4XI: ", count2iterate)                              
    print("\n ITERATIONS ALLOWED OF SHOOT2THREE4XI: ", max2iterate4xi) 
    print("\n REJECTED OF SHOOT2THREE4XI: ", count2rejected, " = ", int(100 * count2rejected/count2iterate), " %") 

    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # SHOW RESULTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           
    print("\n (STEP 30B1/33) OF SHOOT2THREE4XI - WHOLE BALL AFTER ALL OPERATIONS AND WITH MAX2COUNT: ", max2count4xi, 'TIME PRINTED: ', time4xi())  
    
    sphere2return = {}                                                 # only ok shots returned
     
    sphere2show = get_sphere2three4xi()
    dict2keys = sphere2show.keys()
    # 
     
    print("\n (STEP 30B3/33) OF SHOOT2THREE4XI - SHOOTING SAMPLE OF : ", max2count4xi, " SHOTS", "NUMBER OF LAYERS: ", count2layer, ' LATEST DISTANCE: ', d2shot4xi, ' INTERVAL2DISTANCE: ', interval2distance4xi)    
    # 

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # 
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    count2plusx = 0
    count2plusy = 0
    count2plusz = 0
           
    count2minusx = 0
    count2minusy = 0
    count2minusz = 0
    
    count2accepted = 0
    count2rejected = 0
    
    order2key = 1
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # ANALYZE SUCCEEDED SHOTS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
    for key2dict in sorted(dict2keys):
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
            
        try:
            index2x=str.find(key2dict,'x')                               
            x2coordinate = int(key2dict[0:index2x])
            # print("\n (STEP 31/33) X2COORDINATE: ",  x2coordinate)
            if x2coordinate >= 0:
                count2plusx = count2plusx + 1
            else:
                count2minusx = count2minusx + 1    
        except:
            print("\n (STEP 31A/33) OF SHOOT2THREE4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31B/33) OF SHOOT2THREE4XI - INDEX2X: ", index2x)
            
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 
        try:                                   
            index2y=str.find(key2dict,'y')
            y2coordinate = int(key2dict[index2x+1:index2y])
            # print("\n (STEP 31/33) Y2COORDINATE: ",  y2coordinate)
            if y2coordinate >= 0:
                count2plusy = count2plusy + 1
            else:
                count2minusy = count2minusy + 1  
        except:
            print("\n (STEP 31C/33) OF SHOOT2THREE4XI - : *** FAILED WITH KEY2DICT: ", key2dict) 
            print("\n (STEP 31D/33) OF SHOOT2THREE4XI - INDEX2X: ", index2x)
            print("\n (STEP 31E/33) OF SHOOT2THREE4XI - INDEX2Y: ", index2y)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        try:                                                                         
            index2z=str.find(key2dict,'z') 
            z2coordinate = int(key2dict[index2y+1:index2z])
            # print("\n (STEP 31/33) Z2COORDINATE: ",  z2coordinate)
            if z2coordinate >= 0:
                count2plusz = count2plusz + 1
            else:
                count2minusz = count2minusz + 1
        except:
            print("\n (STEP 31F/33) OF SHOOT2THREE4XI - *** FAILED WITH KEY2DICT: ", key2dict)
            print("\n (STEP 31G/33) OF SHOOT2THREE4XI - INDEX2X: ", index2x)
            print("\n (STEP 31H/33) OF SHOOT2THREE4XI - INDEX2Y: ", index2y)
            print("\n (STEP 31I/33) OF SHOOT2THREE4XI - INDEX2Z: ", index2z)
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2x = False    
        if ((x2coordinate >= 0) and (sign2x4xi == '+')):
            ack2x = True
        if ((x2coordinate <= 0) and (sign2x4xi == '-')):
            ack2x = True                        
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2y = False    
        if ((y2coordinate >= 0) and (sign2y4xi == '+')):
            ack2y = True
        if ((y2coordinate <= 0) and (sign2y4xi == '-')):
            ack2y = True     
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # 
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             
        ack2z = False    
        if ((z2coordinate >= 0) and (sign2z4xi == '+')):
            ack2z = True
        if ((z2coordinate <= 0) and (sign2z4xi == '-')):
            ack2z = True     
        
        if ((ack2x is True) and (ack2y is True) and (ack2z is True)                                 # (x,y,z) combination ok
            and((fabs(x2coordinate) > 1) or (fabs(y2coordinate) > 1) or (fabs(z2coordinate) > 1))): # core and skeleton coordinates omitted
            count2accepted = count2accepted + 1                                                                                                      
            print("\n (STEP 31/33) OF SHOOT2THREE4XI - ACCEPTANCE: ", count2accepted, " SHOT: ", order2key, ":", key2dict, " EXPECTED SIGNS: (" , sign2x4xi, ",", sign2y4xi, ",", sign2z4xi, ")") 
            # 
            
            sphere2return[key2dict] = sphere2show[key2dict]
            
        else:
            count2rejected = count2rejected + 1
            # 
                                        
        order2key = order2key +1 
    
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # end of for loop
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          

    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # STATISTICS
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                  
    count2tried = count2accepted + count2rejected 
    
    sum2plus = count2plusz + count2plusy+ count2plusz
    sum2minus = count2minusx + count2minusy+ count2minusz
    sum2total = count2plusx + count2minusx # same also with y and z - coordinate exists only once
            
    print('=' *80)
    print("\n (STEP 32/33) OF SHOOT2THREE4XI - STATISTICS FOR REQUIRED: ", max2count4xi, " SHOTS")     
    print("\n START TIME OF SHOOT2THREE4XI: ", time2start)
    print("\n ACCEPTED OF SHOOT2THREE4XI: ", count2accepted, " = ", int(100*count2accepted/order2key), " %")
    print("\n REJECTED OF SHOOT2THREE4XI: ", count2rejected, " = ", int(100*count2rejected/order2key), " %")
   
    print("\n DISTIBUTION OF SHOOT2THREE4XI X, Y AND Z: ") 
    print("\n +X OF SHOOT2THREE4XI: ", count2plusx, " = ", int(100*count2plusx/sum2total), " %")
    print("\n -X OF SHOOT2THREE4XI: ", count2minusx, " = ", int(100*count2minusx/sum2total), " %") 
   
    print("\n +Y OF SHOOT2THREE4XI: ", count2plusy, " = ", int(100*count2plusy/sum2total), " %")
    print("\n -Y OF SHOOT2THREE4XI: ", count2minusy, " = ", int(100*count2minusy/sum2total), " %") 
   
    print("\n +Z OF SHOOT2THREE4XI: ", count2plusz, " = ", int(100*count2plusz/sum2total), " %")
    print("\n -Z OF SHOOT2THREE4XI: ", count2minusz, " = ", int(100*count2minusz/sum2total), " %") 
              
    
    print("\n SUM2TOTAL OF SHOOT2THREE4XI: ", sum2total, "SUCCESS-RATIO: ", int(100*count2accepted/max2count4xi), " %", " COUNT2LAYER: ", count2layer)
    print("\n START2DISTANCE OF SHOOT2THREE4XI: ", start2distance4xi, " INTERVAL2DISTANCE: ", interval2distance4xi, " MAX2LAYER: ", max2layer4xi, " MAX2COUNT : ", max2count4xi)
    print("\n EXPECTED COORDINATE SIGNS OF SHOOT2THREE4XI: (X"  , sign2x4xi, ",Y", sign2y4xi, ",Z", sign2z4xi, ")") 
    
    print("\n REASONING OF SHOOT2THREE4XI: ")
    if count2accepted >= omax2count4xi:
        print("\n OK SHOOTING OF SHOOT2THREE4XI: ACCEPTED SHOTS ", count2accepted, " >= ", omax2count4xi, " ORIGINALLY REQUIRED, MARIGINAL: ", marginal2count4xi)
        # OK SHOOTING OF SHOOT2THREE4XI: ACCEPTED SHOTS  121  >=  100  ORIGINALLY REQUIRED, MARIGINAL:  1.2 
    else:
        print("\n *** FAILED SHOOTING OF SHOOT2THREE4XI: ACCEPTED SHOT ONLY: ", count2accepted, " < ", omax2count4xi, " REQUIRED !")                                    
    
    print("\n END TIME OF SHOOT2THREE4XI: ", time2end)
    print('=' *80)
    # ================================================================================
    #  (STEP 32/33) OF SHOOT2THREE4XI - STATISTICS FOR REQUIRED:  240  SHOTS
    #  START TIME OF SHOOT2THREE4XI:  10:57:20 06/15/10 Pacific Daylight Time
    #  ACCEPTED OF SHOOT2THREE4XI:  237  =  9  %
    #  REJECTED OF SHOOT2THREE4XI:  2271  =  90  %
    #  DISTIBUTION OF SHOOT2THREE4XI X, Y AND Z: 
    #  +X OF SHOOT2THREE4XI:  1156  =  46  %
    #  -X OF SHOOT2THREE4XI:  1352  =  53  %
    #  +Y OF SHOOT2THREE4XI:  1157  =  46  %
    #  -Y OF SHOOT2THREE4XI:  1351  =  53  %
    #  +Z OF SHOOT2THREE4XI:  1251  =  49  %
    #  -Z OF SHOOT2THREE4XI:  1257  =  50  %
    #  SUM2TOTAL OF SHOOT2THREE4XI:  2508 SUCCESS-RATIO:  98  %  COUNT2LAYER:  3
    #  START2DISTANCE OF SHOOT2THREE4XI:  100  INTERVAL2DISTANCE:  100  MAX2LAYER:  120  MAX2COUNT :  240
    #  EXPECTED COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
    #  REASONING OF SHOOT2THREE4XI: 
    #  OK SHOOTING OF SHOOT2THREE4XI: ACCEPTED SHOTS  237  >=  200  ORIGINALLY REQUIRED, MARIGINAL:  1.2
    #  END TIME OF SHOOT2THREE4XI:  10:59:04 06/15/10 Pacific Daylight Time
    # ================================================================================   
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # RETURN
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if queue2three is None:
        
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # DICTIONARY RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          
        print("\n (STEP 33A/33) OF SHOOT2THREE4XI - RETURNING COORDINATE DICTIONARY AS VARIABLE")   
        return sphere2return
    else:
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # QUEUE RETURNING
        # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ack2put = False
        queue2three4xi = queue2three
        
        print("\n (STEP 33B/33) OF SHOOT2THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE4XI: ", queue2three4xi, " - TIME: ", time4xi())  
        try:
            # -------------------------------------------------------------------------------------
            # PUT DICTIONARY TO QUEUE 
            # -------------------------------------------------------------------------------------                 
            queue2three4xi.put(sphere2return)
            print("\n (STEP 33C/33) OF SHOOT2THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE4XI: ", queue2three4xi, " - TIME: ", time4xi()) 
            # 
            ack2put = True
        except:
            print("\n (STEP 33D/33) OF SHOOT2THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE4XI: ", queue2three4xi, " - TIME: ", time4xi()) 
        
        print("\n (STEP 33E/33) OF SHOOT2THREE4XI - TRYING TO SEND INFORMATION OF PUT-OPERATION VIA PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
        
        
        print("\n (STEP 33E1/33E) OF SHOOT2THREE4XI - TRYING TO WRITE DICTIONARY TO FILE - TIME: ", time4xi()) 
        try:                
            # ---------------------------------------------------------------------------------------------
            # WRITE SHOT TO FILE 
            # ---------------------------------------------------------------------------------------------
            path2file      = '..\\..\\txt\\shot2three4xi.txt'
            text2copyright = '<!-- Copyright Small & Smart - California, United States of America - All rights reserved. -->' + '\n'
       
            
            f2xi=open(path2file, 'w')
            print("\n (STEP 33E2/33E) OF SHOOT2THREE4XI - OPENED FILE: ", path2file, " - TIME: ", time4xi())   
            # 
            
                                
            # ---------------------------------------------------------------------------------------------
            # START
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
              
            # ---------------------------------------------------------------------------------------------
            # BODY
            # ---------------------------------------------------------------------------------------------                 
            keys2write = sorted(sphere2return.keys())

            for key2write in sorted(keys2write):
                line2write = str(key2write) + '\n'
                f2xi.write(line2write)            
                
                line2write = str(sphere2return[key2write]) + '\n'
                f2xi.write(line2write) 
                                
            # ---------------------------------------------------------------------------------------------
            # END
            # ---------------------------------------------------------------------------------------------                 
            f2xi.write(text2copyright)
                
            print("\n (STEP 33F/33) OF SHOOT2THREE4XI -  WROTE SHOT2THREE4XI - TIME: ", time4xi()) 

            # 

            
            # ---------------------------------------------------------------------------------------------
            # 
            # ---------------------------------------------------------------------------------------------                 
            f2xi.close()     
            print("\n (STEP 33G/33) OF SHOOT2THREE4XI -  CLOSED SHOT2THREE4XI - TIME: ", time4xi()) 
            # 
             
        except:
            print("\n (STEP 33X/33) OF SHOOT2THREE4XI *** FAILED TO WRITE SHOT2THREE4XI - TIME: ", time4xi())
        
                            
             
        try:                
            # ---------------------------------------------------------------------------------------------
            # INFORM PUT OPERATION VIA PIPE'S PUBLISHER CHANNEL 
            # ---------------------------------------------------------------------------------------------
            if ack2put is True:
                message2send4three = "<ack2put4xi>queue2three</ack2put4xi>"
            else:
                message2send4three = "<nack2put4xi>queue2three</nack2put4xi>" 
 
            publisher_channel2three.send(message2send4three)
            print(" (STEP 33G/33) OF SHOOT2THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())  
            # <ack2put4xi>queue2three</ack2put4xi>  TO PUBLISHER_CHANNEL2THREE:  <read-write PipeConnection, handle 260>  - TIME:  04:42:33 06/20/10 Pacific Daylight Time 
        except:
            print(" (STEP 33H/33) OF SHOOT2THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 

        print("\n (STEP 33I/33) OF SHOOT2THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE4XI: ", queue2three4xi, " - TIME: ", time4xi())  
         
        return queue2three4xi    

#</function4xi>

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of shoot2three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
